//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private noftDynamicVolumeProfile[] cachenoftDynamicVolumeProfile = null;

        private static noftDynamicVolumeProfile checknoftDynamicVolumeProfile = new noftDynamicVolumeProfile();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftDynamicVolumeProfile noftDynamicVolumeProfile(string calculationBarType, string drawSide, string drawStyle, Plot extendedHighLine, Plot extendedLowLine, int extendHighLine, int extendLowLine, bool extendMaxVapToEndZone, int extendVAHighLine, int extendVALowLine, int extendVPOCLine, bool heatColor, bool heatColorFill, Plot maxVap, bool showRangeHorizontalLine, bool showRangeVerticalLine, bool showVaHighLine, bool showVaLowLine, bool showZoneVerticalLine, Color valueAreaColor, int valueAreaColorAlpha, Plot valueAreaHighLine, int valueAreaLevel, Plot valueAreaLowLine, Color vapColor, int vapColorAlpha, Plot vAPOutline, int vapWidthPercent, Plot zoneBorder)
        {
            return noftDynamicVolumeProfile(Input, calculationBarType, drawSide, drawStyle, extendedHighLine, extendedLowLine, extendHighLine, extendLowLine, extendMaxVapToEndZone, extendVAHighLine, extendVALowLine, extendVPOCLine, heatColor, heatColorFill, maxVap, showRangeHorizontalLine, showRangeVerticalLine, showVaHighLine, showVaLowLine, showZoneVerticalLine, valueAreaColor, valueAreaColorAlpha, valueAreaHighLine, valueAreaLevel, valueAreaLowLine, vapColor, vapColorAlpha, vAPOutline, vapWidthPercent, zoneBorder);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftDynamicVolumeProfile noftDynamicVolumeProfile(Data.IDataSeries input, string calculationBarType, string drawSide, string drawStyle, Plot extendedHighLine, Plot extendedLowLine, int extendHighLine, int extendLowLine, bool extendMaxVapToEndZone, int extendVAHighLine, int extendVALowLine, int extendVPOCLine, bool heatColor, bool heatColorFill, Plot maxVap, bool showRangeHorizontalLine, bool showRangeVerticalLine, bool showVaHighLine, bool showVaLowLine, bool showZoneVerticalLine, Color valueAreaColor, int valueAreaColorAlpha, Plot valueAreaHighLine, int valueAreaLevel, Plot valueAreaLowLine, Color vapColor, int vapColorAlpha, Plot vAPOutline, int vapWidthPercent, Plot zoneBorder)
        {
            if (cachenoftDynamicVolumeProfile != null)
                for (int idx = 0; idx < cachenoftDynamicVolumeProfile.Length; idx++)
                    if (cachenoftDynamicVolumeProfile[idx].CalculationBarType == calculationBarType && cachenoftDynamicVolumeProfile[idx].DrawSide == drawSide && cachenoftDynamicVolumeProfile[idx].DrawStyle == drawStyle && cachenoftDynamicVolumeProfile[idx].ExtendedHighLine == extendedHighLine && cachenoftDynamicVolumeProfile[idx].ExtendedLowLine == extendedLowLine && cachenoftDynamicVolumeProfile[idx].ExtendHighLine == extendHighLine && cachenoftDynamicVolumeProfile[idx].ExtendLowLine == extendLowLine && cachenoftDynamicVolumeProfile[idx].ExtendMaxVapToEndZone == extendMaxVapToEndZone && cachenoftDynamicVolumeProfile[idx].ExtendVAHighLine == extendVAHighLine && cachenoftDynamicVolumeProfile[idx].ExtendVALowLine == extendVALowLine && cachenoftDynamicVolumeProfile[idx].ExtendVPOCLine == extendVPOCLine && cachenoftDynamicVolumeProfile[idx].HeatColor == heatColor && cachenoftDynamicVolumeProfile[idx].HeatColorFill == heatColorFill && cachenoftDynamicVolumeProfile[idx].MaxVap == maxVap && cachenoftDynamicVolumeProfile[idx].ShowRangeHorizontalLine == showRangeHorizontalLine && cachenoftDynamicVolumeProfile[idx].ShowRangeVerticalLine == showRangeVerticalLine && cachenoftDynamicVolumeProfile[idx].ShowVaHighLine == showVaHighLine && cachenoftDynamicVolumeProfile[idx].ShowVaLowLine == showVaLowLine && cachenoftDynamicVolumeProfile[idx].ShowZoneVerticalLine == showZoneVerticalLine && cachenoftDynamicVolumeProfile[idx].ValueAreaColor == valueAreaColor && cachenoftDynamicVolumeProfile[idx].ValueAreaColorAlpha == valueAreaColorAlpha && cachenoftDynamicVolumeProfile[idx].ValueAreaHighLine == valueAreaHighLine && cachenoftDynamicVolumeProfile[idx].ValueAreaLevel == valueAreaLevel && cachenoftDynamicVolumeProfile[idx].ValueAreaLowLine == valueAreaLowLine && cachenoftDynamicVolumeProfile[idx].VapColor == vapColor && cachenoftDynamicVolumeProfile[idx].VapColorAlpha == vapColorAlpha && cachenoftDynamicVolumeProfile[idx].VAPOutline == vAPOutline && cachenoftDynamicVolumeProfile[idx].VapWidthPercent == vapWidthPercent && cachenoftDynamicVolumeProfile[idx].ZoneBorder == zoneBorder && cachenoftDynamicVolumeProfile[idx].EqualsInput(input))
                        return cachenoftDynamicVolumeProfile[idx];

            lock (checknoftDynamicVolumeProfile)
            {
                checknoftDynamicVolumeProfile.CalculationBarType = calculationBarType;
                calculationBarType = checknoftDynamicVolumeProfile.CalculationBarType;
                checknoftDynamicVolumeProfile.DrawSide = drawSide;
                drawSide = checknoftDynamicVolumeProfile.DrawSide;
                checknoftDynamicVolumeProfile.DrawStyle = drawStyle;
                drawStyle = checknoftDynamicVolumeProfile.DrawStyle;
                checknoftDynamicVolumeProfile.ExtendedHighLine = extendedHighLine;
                extendedHighLine = checknoftDynamicVolumeProfile.ExtendedHighLine;
                checknoftDynamicVolumeProfile.ExtendedLowLine = extendedLowLine;
                extendedLowLine = checknoftDynamicVolumeProfile.ExtendedLowLine;
                checknoftDynamicVolumeProfile.ExtendHighLine = extendHighLine;
                extendHighLine = checknoftDynamicVolumeProfile.ExtendHighLine;
                checknoftDynamicVolumeProfile.ExtendLowLine = extendLowLine;
                extendLowLine = checknoftDynamicVolumeProfile.ExtendLowLine;
                checknoftDynamicVolumeProfile.ExtendMaxVapToEndZone = extendMaxVapToEndZone;
                extendMaxVapToEndZone = checknoftDynamicVolumeProfile.ExtendMaxVapToEndZone;
                checknoftDynamicVolumeProfile.ExtendVAHighLine = extendVAHighLine;
                extendVAHighLine = checknoftDynamicVolumeProfile.ExtendVAHighLine;
                checknoftDynamicVolumeProfile.ExtendVALowLine = extendVALowLine;
                extendVALowLine = checknoftDynamicVolumeProfile.ExtendVALowLine;
                checknoftDynamicVolumeProfile.ExtendVPOCLine = extendVPOCLine;
                extendVPOCLine = checknoftDynamicVolumeProfile.ExtendVPOCLine;
                checknoftDynamicVolumeProfile.HeatColor = heatColor;
                heatColor = checknoftDynamicVolumeProfile.HeatColor;
                checknoftDynamicVolumeProfile.HeatColorFill = heatColorFill;
                heatColorFill = checknoftDynamicVolumeProfile.HeatColorFill;
                checknoftDynamicVolumeProfile.MaxVap = maxVap;
                maxVap = checknoftDynamicVolumeProfile.MaxVap;
                checknoftDynamicVolumeProfile.ShowRangeHorizontalLine = showRangeHorizontalLine;
                showRangeHorizontalLine = checknoftDynamicVolumeProfile.ShowRangeHorizontalLine;
                checknoftDynamicVolumeProfile.ShowRangeVerticalLine = showRangeVerticalLine;
                showRangeVerticalLine = checknoftDynamicVolumeProfile.ShowRangeVerticalLine;
                checknoftDynamicVolumeProfile.ShowVaHighLine = showVaHighLine;
                showVaHighLine = checknoftDynamicVolumeProfile.ShowVaHighLine;
                checknoftDynamicVolumeProfile.ShowVaLowLine = showVaLowLine;
                showVaLowLine = checknoftDynamicVolumeProfile.ShowVaLowLine;
                checknoftDynamicVolumeProfile.ShowZoneVerticalLine = showZoneVerticalLine;
                showZoneVerticalLine = checknoftDynamicVolumeProfile.ShowZoneVerticalLine;
                checknoftDynamicVolumeProfile.ValueAreaColor = valueAreaColor;
                valueAreaColor = checknoftDynamicVolumeProfile.ValueAreaColor;
                checknoftDynamicVolumeProfile.ValueAreaColorAlpha = valueAreaColorAlpha;
                valueAreaColorAlpha = checknoftDynamicVolumeProfile.ValueAreaColorAlpha;
                checknoftDynamicVolumeProfile.ValueAreaHighLine = valueAreaHighLine;
                valueAreaHighLine = checknoftDynamicVolumeProfile.ValueAreaHighLine;
                checknoftDynamicVolumeProfile.ValueAreaLevel = valueAreaLevel;
                valueAreaLevel = checknoftDynamicVolumeProfile.ValueAreaLevel;
                checknoftDynamicVolumeProfile.ValueAreaLowLine = valueAreaLowLine;
                valueAreaLowLine = checknoftDynamicVolumeProfile.ValueAreaLowLine;
                checknoftDynamicVolumeProfile.VapColor = vapColor;
                vapColor = checknoftDynamicVolumeProfile.VapColor;
                checknoftDynamicVolumeProfile.VapColorAlpha = vapColorAlpha;
                vapColorAlpha = checknoftDynamicVolumeProfile.VapColorAlpha;
                checknoftDynamicVolumeProfile.VAPOutline = vAPOutline;
                vAPOutline = checknoftDynamicVolumeProfile.VAPOutline;
                checknoftDynamicVolumeProfile.VapWidthPercent = vapWidthPercent;
                vapWidthPercent = checknoftDynamicVolumeProfile.VapWidthPercent;
                checknoftDynamicVolumeProfile.ZoneBorder = zoneBorder;
                zoneBorder = checknoftDynamicVolumeProfile.ZoneBorder;

                if (cachenoftDynamicVolumeProfile != null)
                    for (int idx = 0; idx < cachenoftDynamicVolumeProfile.Length; idx++)
                        if (cachenoftDynamicVolumeProfile[idx].CalculationBarType == calculationBarType && cachenoftDynamicVolumeProfile[idx].DrawSide == drawSide && cachenoftDynamicVolumeProfile[idx].DrawStyle == drawStyle && cachenoftDynamicVolumeProfile[idx].ExtendedHighLine == extendedHighLine && cachenoftDynamicVolumeProfile[idx].ExtendedLowLine == extendedLowLine && cachenoftDynamicVolumeProfile[idx].ExtendHighLine == extendHighLine && cachenoftDynamicVolumeProfile[idx].ExtendLowLine == extendLowLine && cachenoftDynamicVolumeProfile[idx].ExtendMaxVapToEndZone == extendMaxVapToEndZone && cachenoftDynamicVolumeProfile[idx].ExtendVAHighLine == extendVAHighLine && cachenoftDynamicVolumeProfile[idx].ExtendVALowLine == extendVALowLine && cachenoftDynamicVolumeProfile[idx].ExtendVPOCLine == extendVPOCLine && cachenoftDynamicVolumeProfile[idx].HeatColor == heatColor && cachenoftDynamicVolumeProfile[idx].HeatColorFill == heatColorFill && cachenoftDynamicVolumeProfile[idx].MaxVap == maxVap && cachenoftDynamicVolumeProfile[idx].ShowRangeHorizontalLine == showRangeHorizontalLine && cachenoftDynamicVolumeProfile[idx].ShowRangeVerticalLine == showRangeVerticalLine && cachenoftDynamicVolumeProfile[idx].ShowVaHighLine == showVaHighLine && cachenoftDynamicVolumeProfile[idx].ShowVaLowLine == showVaLowLine && cachenoftDynamicVolumeProfile[idx].ShowZoneVerticalLine == showZoneVerticalLine && cachenoftDynamicVolumeProfile[idx].ValueAreaColor == valueAreaColor && cachenoftDynamicVolumeProfile[idx].ValueAreaColorAlpha == valueAreaColorAlpha && cachenoftDynamicVolumeProfile[idx].ValueAreaHighLine == valueAreaHighLine && cachenoftDynamicVolumeProfile[idx].ValueAreaLevel == valueAreaLevel && cachenoftDynamicVolumeProfile[idx].ValueAreaLowLine == valueAreaLowLine && cachenoftDynamicVolumeProfile[idx].VapColor == vapColor && cachenoftDynamicVolumeProfile[idx].VapColorAlpha == vapColorAlpha && cachenoftDynamicVolumeProfile[idx].VAPOutline == vAPOutline && cachenoftDynamicVolumeProfile[idx].VapWidthPercent == vapWidthPercent && cachenoftDynamicVolumeProfile[idx].ZoneBorder == zoneBorder && cachenoftDynamicVolumeProfile[idx].EqualsInput(input))
                            return cachenoftDynamicVolumeProfile[idx];

                noftDynamicVolumeProfile indicator = new noftDynamicVolumeProfile();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.CalculationBarType = calculationBarType;
                indicator.DrawSide = drawSide;
                indicator.DrawStyle = drawStyle;
                indicator.ExtendedHighLine = extendedHighLine;
                indicator.ExtendedLowLine = extendedLowLine;
                indicator.ExtendHighLine = extendHighLine;
                indicator.ExtendLowLine = extendLowLine;
                indicator.ExtendMaxVapToEndZone = extendMaxVapToEndZone;
                indicator.ExtendVAHighLine = extendVAHighLine;
                indicator.ExtendVALowLine = extendVALowLine;
                indicator.ExtendVPOCLine = extendVPOCLine;
                indicator.HeatColor = heatColor;
                indicator.HeatColorFill = heatColorFill;
                indicator.MaxVap = maxVap;
                indicator.ShowRangeHorizontalLine = showRangeHorizontalLine;
                indicator.ShowRangeVerticalLine = showRangeVerticalLine;
                indicator.ShowVaHighLine = showVaHighLine;
                indicator.ShowVaLowLine = showVaLowLine;
                indicator.ShowZoneVerticalLine = showZoneVerticalLine;
                indicator.ValueAreaColor = valueAreaColor;
                indicator.ValueAreaColorAlpha = valueAreaColorAlpha;
                indicator.ValueAreaHighLine = valueAreaHighLine;
                indicator.ValueAreaLevel = valueAreaLevel;
                indicator.ValueAreaLowLine = valueAreaLowLine;
                indicator.VapColor = vapColor;
                indicator.VapColorAlpha = vapColorAlpha;
                indicator.VAPOutline = vAPOutline;
                indicator.VapWidthPercent = vapWidthPercent;
                indicator.ZoneBorder = zoneBorder;
                Indicators.Add(indicator);
                indicator.SetUp();

                noftDynamicVolumeProfile[] tmp = new noftDynamicVolumeProfile[cachenoftDynamicVolumeProfile == null ? 1 : cachenoftDynamicVolumeProfile.Length + 1];
                if (cachenoftDynamicVolumeProfile != null)
                    cachenoftDynamicVolumeProfile.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachenoftDynamicVolumeProfile = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftDynamicVolumeProfile noftDynamicVolumeProfile(string calculationBarType, string drawSide, string drawStyle, Plot extendedHighLine, Plot extendedLowLine, int extendHighLine, int extendLowLine, bool extendMaxVapToEndZone, int extendVAHighLine, int extendVALowLine, int extendVPOCLine, bool heatColor, bool heatColorFill, Plot maxVap, bool showRangeHorizontalLine, bool showRangeVerticalLine, bool showVaHighLine, bool showVaLowLine, bool showZoneVerticalLine, Color valueAreaColor, int valueAreaColorAlpha, Plot valueAreaHighLine, int valueAreaLevel, Plot valueAreaLowLine, Color vapColor, int vapColorAlpha, Plot vAPOutline, int vapWidthPercent, Plot zoneBorder)
        {
            return _indicator.noftDynamicVolumeProfile(Input, calculationBarType, drawSide, drawStyle, extendedHighLine, extendedLowLine, extendHighLine, extendLowLine, extendMaxVapToEndZone, extendVAHighLine, extendVALowLine, extendVPOCLine, heatColor, heatColorFill, maxVap, showRangeHorizontalLine, showRangeVerticalLine, showVaHighLine, showVaLowLine, showZoneVerticalLine, valueAreaColor, valueAreaColorAlpha, valueAreaHighLine, valueAreaLevel, valueAreaLowLine, vapColor, vapColorAlpha, vAPOutline, vapWidthPercent, zoneBorder);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftDynamicVolumeProfile noftDynamicVolumeProfile(Data.IDataSeries input, string calculationBarType, string drawSide, string drawStyle, Plot extendedHighLine, Plot extendedLowLine, int extendHighLine, int extendLowLine, bool extendMaxVapToEndZone, int extendVAHighLine, int extendVALowLine, int extendVPOCLine, bool heatColor, bool heatColorFill, Plot maxVap, bool showRangeHorizontalLine, bool showRangeVerticalLine, bool showVaHighLine, bool showVaLowLine, bool showZoneVerticalLine, Color valueAreaColor, int valueAreaColorAlpha, Plot valueAreaHighLine, int valueAreaLevel, Plot valueAreaLowLine, Color vapColor, int vapColorAlpha, Plot vAPOutline, int vapWidthPercent, Plot zoneBorder)
        {
            return _indicator.noftDynamicVolumeProfile(input, calculationBarType, drawSide, drawStyle, extendedHighLine, extendedLowLine, extendHighLine, extendLowLine, extendMaxVapToEndZone, extendVAHighLine, extendVALowLine, extendVPOCLine, heatColor, heatColorFill, maxVap, showRangeHorizontalLine, showRangeVerticalLine, showVaHighLine, showVaLowLine, showZoneVerticalLine, valueAreaColor, valueAreaColorAlpha, valueAreaHighLine, valueAreaLevel, valueAreaLowLine, vapColor, vapColorAlpha, vAPOutline, vapWidthPercent, zoneBorder);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftDynamicVolumeProfile noftDynamicVolumeProfile(string calculationBarType, string drawSide, string drawStyle, Plot extendedHighLine, Plot extendedLowLine, int extendHighLine, int extendLowLine, bool extendMaxVapToEndZone, int extendVAHighLine, int extendVALowLine, int extendVPOCLine, bool heatColor, bool heatColorFill, Plot maxVap, bool showRangeHorizontalLine, bool showRangeVerticalLine, bool showVaHighLine, bool showVaLowLine, bool showZoneVerticalLine, Color valueAreaColor, int valueAreaColorAlpha, Plot valueAreaHighLine, int valueAreaLevel, Plot valueAreaLowLine, Color vapColor, int vapColorAlpha, Plot vAPOutline, int vapWidthPercent, Plot zoneBorder)
        {
            return _indicator.noftDynamicVolumeProfile(Input, calculationBarType, drawSide, drawStyle, extendedHighLine, extendedLowLine, extendHighLine, extendLowLine, extendMaxVapToEndZone, extendVAHighLine, extendVALowLine, extendVPOCLine, heatColor, heatColorFill, maxVap, showRangeHorizontalLine, showRangeVerticalLine, showVaHighLine, showVaLowLine, showZoneVerticalLine, valueAreaColor, valueAreaColorAlpha, valueAreaHighLine, valueAreaLevel, valueAreaLowLine, vapColor, vapColorAlpha, vAPOutline, vapWidthPercent, zoneBorder);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftDynamicVolumeProfile noftDynamicVolumeProfile(Data.IDataSeries input, string calculationBarType, string drawSide, string drawStyle, Plot extendedHighLine, Plot extendedLowLine, int extendHighLine, int extendLowLine, bool extendMaxVapToEndZone, int extendVAHighLine, int extendVALowLine, int extendVPOCLine, bool heatColor, bool heatColorFill, Plot maxVap, bool showRangeHorizontalLine, bool showRangeVerticalLine, bool showVaHighLine, bool showVaLowLine, bool showZoneVerticalLine, Color valueAreaColor, int valueAreaColorAlpha, Plot valueAreaHighLine, int valueAreaLevel, Plot valueAreaLowLine, Color vapColor, int vapColorAlpha, Plot vAPOutline, int vapWidthPercent, Plot zoneBorder)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.noftDynamicVolumeProfile(input, calculationBarType, drawSide, drawStyle, extendedHighLine, extendedLowLine, extendHighLine, extendLowLine, extendMaxVapToEndZone, extendVAHighLine, extendVALowLine, extendVPOCLine, heatColor, heatColorFill, maxVap, showRangeHorizontalLine, showRangeVerticalLine, showVaHighLine, showVaLowLine, showZoneVerticalLine, valueAreaColor, valueAreaColorAlpha, valueAreaHighLine, valueAreaLevel, valueAreaLowLine, vapColor, vapColorAlpha, vAPOutline, vapWidthPercent, zoneBorder);
        }
    }
}
#endregion
