//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private noftGhostiBlock[] cachenoftGhostiBlock = null;
        private MarketDeltaMini[] cacheMarketDeltaMini = null;

        private static noftGhostiBlock checknoftGhostiBlock = new noftGhostiBlock();
        private static MarketDeltaMini checkMarketDeltaMini = new MarketDeltaMini();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftGhostiBlock noftGhostiBlock(int askThreshold, int bidThreshold, Color blockBuyBackground, Color blockBuyBorder, int blockBuyOpacity, int blockFrame, int blockMinBuySize, int blockMinSellSize, Color blockSellBackground, Color blockSellBorder, int blockSellOpacity, string blockSide, int blockZoneHeight, int blockZoneTimeoutValue, string blockZoneTimeoutType, int blockZoneWidth, int minStackSize, string signalSound, Color stackedBuyBackground, Color stackedBuyBorder, int stackedBuyOpacity, int stackedFrame, int stackedLevels, Color stackedSellBackground, Color stackedSellBorder, int stackedSellOpacity, string stackedSide, string stackedSound, int stackedTimeoutValue, string stackedTimeoutType)
        {
            return noftGhostiBlock(Input, askThreshold, bidThreshold, blockBuyBackground, blockBuyBorder, blockBuyOpacity, blockFrame, blockMinBuySize, blockMinSellSize, blockSellBackground, blockSellBorder, blockSellOpacity, blockSide, blockZoneHeight, blockZoneTimeoutValue, blockZoneTimeoutType, blockZoneWidth, minStackSize, signalSound, stackedBuyBackground, stackedBuyBorder, stackedBuyOpacity, stackedFrame, stackedLevels, stackedSellBackground, stackedSellBorder, stackedSellOpacity, stackedSide, stackedSound, stackedTimeoutValue, stackedTimeoutType);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftGhostiBlock noftGhostiBlock(Data.IDataSeries input, int askThreshold, int bidThreshold, Color blockBuyBackground, Color blockBuyBorder, int blockBuyOpacity, int blockFrame, int blockMinBuySize, int blockMinSellSize, Color blockSellBackground, Color blockSellBorder, int blockSellOpacity, string blockSide, int blockZoneHeight, int blockZoneTimeoutValue, string blockZoneTimeoutType, int blockZoneWidth, int minStackSize, string signalSound, Color stackedBuyBackground, Color stackedBuyBorder, int stackedBuyOpacity, int stackedFrame, int stackedLevels, Color stackedSellBackground, Color stackedSellBorder, int stackedSellOpacity, string stackedSide, string stackedSound, int stackedTimeoutValue, string stackedTimeoutType)
        {
            if (cachenoftGhostiBlock != null)
                for (int idx = 0; idx < cachenoftGhostiBlock.Length; idx++)
                    if (cachenoftGhostiBlock[idx].AskThreshold == askThreshold && cachenoftGhostiBlock[idx].BidThreshold == bidThreshold && cachenoftGhostiBlock[idx].BlockBuyBackground == blockBuyBackground && cachenoftGhostiBlock[idx].BlockBuyBorder == blockBuyBorder && cachenoftGhostiBlock[idx].BlockBuyOpacity == blockBuyOpacity && cachenoftGhostiBlock[idx].BlockFrame == blockFrame && cachenoftGhostiBlock[idx].BlockMinBuySize == blockMinBuySize && cachenoftGhostiBlock[idx].BlockMinSellSize == blockMinSellSize && cachenoftGhostiBlock[idx].BlockSellBackground == blockSellBackground && cachenoftGhostiBlock[idx].BlockSellBorder == blockSellBorder && cachenoftGhostiBlock[idx].BlockSellOpacity == blockSellOpacity && cachenoftGhostiBlock[idx].BlockSide == blockSide && cachenoftGhostiBlock[idx].BlockZoneHeight == blockZoneHeight && cachenoftGhostiBlock[idx].BlockZoneTimeoutValue == blockZoneTimeoutValue && cachenoftGhostiBlock[idx].BlockZoneTimeoutType == blockZoneTimeoutType && cachenoftGhostiBlock[idx].BlockZoneWidth == blockZoneWidth && cachenoftGhostiBlock[idx].MinStackSize == minStackSize && cachenoftGhostiBlock[idx].SignalSound == signalSound && cachenoftGhostiBlock[idx].StackedBuyBackground == stackedBuyBackground && cachenoftGhostiBlock[idx].StackedBuyBorder == stackedBuyBorder && cachenoftGhostiBlock[idx].StackedBuyOpacity == stackedBuyOpacity && cachenoftGhostiBlock[idx].StackedFrame == stackedFrame && cachenoftGhostiBlock[idx].StackedLevels == stackedLevels && cachenoftGhostiBlock[idx].StackedSellBackground == stackedSellBackground && cachenoftGhostiBlock[idx].StackedSellBorder == stackedSellBorder && cachenoftGhostiBlock[idx].StackedSellOpacity == stackedSellOpacity && cachenoftGhostiBlock[idx].StackedSide == stackedSide && cachenoftGhostiBlock[idx].StackedSound == stackedSound && cachenoftGhostiBlock[idx].StackedTimeoutValue == stackedTimeoutValue && cachenoftGhostiBlock[idx].StackedTimeoutType == stackedTimeoutType && cachenoftGhostiBlock[idx].EqualsInput(input))
                        return cachenoftGhostiBlock[idx];

            lock (checknoftGhostiBlock)
            {
                checknoftGhostiBlock.AskThreshold = askThreshold;
                askThreshold = checknoftGhostiBlock.AskThreshold;
                checknoftGhostiBlock.BidThreshold = bidThreshold;
                bidThreshold = checknoftGhostiBlock.BidThreshold;
                checknoftGhostiBlock.BlockBuyBackground = blockBuyBackground;
                blockBuyBackground = checknoftGhostiBlock.BlockBuyBackground;
                checknoftGhostiBlock.BlockBuyBorder = blockBuyBorder;
                blockBuyBorder = checknoftGhostiBlock.BlockBuyBorder;
                checknoftGhostiBlock.BlockBuyOpacity = blockBuyOpacity;
                blockBuyOpacity = checknoftGhostiBlock.BlockBuyOpacity;
                checknoftGhostiBlock.BlockFrame = blockFrame;
                blockFrame = checknoftGhostiBlock.BlockFrame;
                checknoftGhostiBlock.BlockMinBuySize = blockMinBuySize;
                blockMinBuySize = checknoftGhostiBlock.BlockMinBuySize;
                checknoftGhostiBlock.BlockMinSellSize = blockMinSellSize;
                blockMinSellSize = checknoftGhostiBlock.BlockMinSellSize;
                checknoftGhostiBlock.BlockSellBackground = blockSellBackground;
                blockSellBackground = checknoftGhostiBlock.BlockSellBackground;
                checknoftGhostiBlock.BlockSellBorder = blockSellBorder;
                blockSellBorder = checknoftGhostiBlock.BlockSellBorder;
                checknoftGhostiBlock.BlockSellOpacity = blockSellOpacity;
                blockSellOpacity = checknoftGhostiBlock.BlockSellOpacity;
                checknoftGhostiBlock.BlockSide = blockSide;
                blockSide = checknoftGhostiBlock.BlockSide;
                checknoftGhostiBlock.BlockZoneHeight = blockZoneHeight;
                blockZoneHeight = checknoftGhostiBlock.BlockZoneHeight;
                checknoftGhostiBlock.BlockZoneTimeoutValue = blockZoneTimeoutValue;
                blockZoneTimeoutValue = checknoftGhostiBlock.BlockZoneTimeoutValue;
                checknoftGhostiBlock.BlockZoneTimeoutType = blockZoneTimeoutType;
                blockZoneTimeoutType = checknoftGhostiBlock.BlockZoneTimeoutType;
                checknoftGhostiBlock.BlockZoneWidth = blockZoneWidth;
                blockZoneWidth = checknoftGhostiBlock.BlockZoneWidth;
                checknoftGhostiBlock.MinStackSize = minStackSize;
                minStackSize = checknoftGhostiBlock.MinStackSize;
                checknoftGhostiBlock.SignalSound = signalSound;
                signalSound = checknoftGhostiBlock.SignalSound;
                checknoftGhostiBlock.StackedBuyBackground = stackedBuyBackground;
                stackedBuyBackground = checknoftGhostiBlock.StackedBuyBackground;
                checknoftGhostiBlock.StackedBuyBorder = stackedBuyBorder;
                stackedBuyBorder = checknoftGhostiBlock.StackedBuyBorder;
                checknoftGhostiBlock.StackedBuyOpacity = stackedBuyOpacity;
                stackedBuyOpacity = checknoftGhostiBlock.StackedBuyOpacity;
                checknoftGhostiBlock.StackedFrame = stackedFrame;
                stackedFrame = checknoftGhostiBlock.StackedFrame;
                checknoftGhostiBlock.StackedLevels = stackedLevels;
                stackedLevels = checknoftGhostiBlock.StackedLevels;
                checknoftGhostiBlock.StackedSellBackground = stackedSellBackground;
                stackedSellBackground = checknoftGhostiBlock.StackedSellBackground;
                checknoftGhostiBlock.StackedSellBorder = stackedSellBorder;
                stackedSellBorder = checknoftGhostiBlock.StackedSellBorder;
                checknoftGhostiBlock.StackedSellOpacity = stackedSellOpacity;
                stackedSellOpacity = checknoftGhostiBlock.StackedSellOpacity;
                checknoftGhostiBlock.StackedSide = stackedSide;
                stackedSide = checknoftGhostiBlock.StackedSide;
                checknoftGhostiBlock.StackedSound = stackedSound;
                stackedSound = checknoftGhostiBlock.StackedSound;
                checknoftGhostiBlock.StackedTimeoutValue = stackedTimeoutValue;
                stackedTimeoutValue = checknoftGhostiBlock.StackedTimeoutValue;
                checknoftGhostiBlock.StackedTimeoutType = stackedTimeoutType;
                stackedTimeoutType = checknoftGhostiBlock.StackedTimeoutType;

                if (cachenoftGhostiBlock != null)
                    for (int idx = 0; idx < cachenoftGhostiBlock.Length; idx++)
                        if (cachenoftGhostiBlock[idx].AskThreshold == askThreshold && cachenoftGhostiBlock[idx].BidThreshold == bidThreshold && cachenoftGhostiBlock[idx].BlockBuyBackground == blockBuyBackground && cachenoftGhostiBlock[idx].BlockBuyBorder == blockBuyBorder && cachenoftGhostiBlock[idx].BlockBuyOpacity == blockBuyOpacity && cachenoftGhostiBlock[idx].BlockFrame == blockFrame && cachenoftGhostiBlock[idx].BlockMinBuySize == blockMinBuySize && cachenoftGhostiBlock[idx].BlockMinSellSize == blockMinSellSize && cachenoftGhostiBlock[idx].BlockSellBackground == blockSellBackground && cachenoftGhostiBlock[idx].BlockSellBorder == blockSellBorder && cachenoftGhostiBlock[idx].BlockSellOpacity == blockSellOpacity && cachenoftGhostiBlock[idx].BlockSide == blockSide && cachenoftGhostiBlock[idx].BlockZoneHeight == blockZoneHeight && cachenoftGhostiBlock[idx].BlockZoneTimeoutValue == blockZoneTimeoutValue && cachenoftGhostiBlock[idx].BlockZoneTimeoutType == blockZoneTimeoutType && cachenoftGhostiBlock[idx].BlockZoneWidth == blockZoneWidth && cachenoftGhostiBlock[idx].MinStackSize == minStackSize && cachenoftGhostiBlock[idx].SignalSound == signalSound && cachenoftGhostiBlock[idx].StackedBuyBackground == stackedBuyBackground && cachenoftGhostiBlock[idx].StackedBuyBorder == stackedBuyBorder && cachenoftGhostiBlock[idx].StackedBuyOpacity == stackedBuyOpacity && cachenoftGhostiBlock[idx].StackedFrame == stackedFrame && cachenoftGhostiBlock[idx].StackedLevels == stackedLevels && cachenoftGhostiBlock[idx].StackedSellBackground == stackedSellBackground && cachenoftGhostiBlock[idx].StackedSellBorder == stackedSellBorder && cachenoftGhostiBlock[idx].StackedSellOpacity == stackedSellOpacity && cachenoftGhostiBlock[idx].StackedSide == stackedSide && cachenoftGhostiBlock[idx].StackedSound == stackedSound && cachenoftGhostiBlock[idx].StackedTimeoutValue == stackedTimeoutValue && cachenoftGhostiBlock[idx].StackedTimeoutType == stackedTimeoutType && cachenoftGhostiBlock[idx].EqualsInput(input))
                            return cachenoftGhostiBlock[idx];

                noftGhostiBlock indicator = new noftGhostiBlock();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.AskThreshold = askThreshold;
                indicator.BidThreshold = bidThreshold;
                indicator.BlockBuyBackground = blockBuyBackground;
                indicator.BlockBuyBorder = blockBuyBorder;
                indicator.BlockBuyOpacity = blockBuyOpacity;
                indicator.BlockFrame = blockFrame;
                indicator.BlockMinBuySize = blockMinBuySize;
                indicator.BlockMinSellSize = blockMinSellSize;
                indicator.BlockSellBackground = blockSellBackground;
                indicator.BlockSellBorder = blockSellBorder;
                indicator.BlockSellOpacity = blockSellOpacity;
                indicator.BlockSide = blockSide;
                indicator.BlockZoneHeight = blockZoneHeight;
                indicator.BlockZoneTimeoutValue = blockZoneTimeoutValue;
                indicator.BlockZoneTimeoutType = blockZoneTimeoutType;
                indicator.BlockZoneWidth = blockZoneWidth;
                indicator.MinStackSize = minStackSize;
                indicator.SignalSound = signalSound;
                indicator.StackedBuyBackground = stackedBuyBackground;
                indicator.StackedBuyBorder = stackedBuyBorder;
                indicator.StackedBuyOpacity = stackedBuyOpacity;
                indicator.StackedFrame = stackedFrame;
                indicator.StackedLevels = stackedLevels;
                indicator.StackedSellBackground = stackedSellBackground;
                indicator.StackedSellBorder = stackedSellBorder;
                indicator.StackedSellOpacity = stackedSellOpacity;
                indicator.StackedSide = stackedSide;
                indicator.StackedSound = stackedSound;
                indicator.StackedTimeoutValue = stackedTimeoutValue;
                indicator.StackedTimeoutType = stackedTimeoutType;
                Indicators.Add(indicator);
                indicator.SetUp();

                noftGhostiBlock[] tmp = new noftGhostiBlock[cachenoftGhostiBlock == null ? 1 : cachenoftGhostiBlock.Length + 1];
                if (cachenoftGhostiBlock != null)
                    cachenoftGhostiBlock.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachenoftGhostiBlock = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public MarketDeltaMini MarketDeltaMini(int askIncCount, int bidDecCount, int cotBand)
        {
            return MarketDeltaMini(Input, askIncCount, bidDecCount, cotBand);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public MarketDeltaMini MarketDeltaMini(Data.IDataSeries input, int askIncCount, int bidDecCount, int cotBand)
        {
            if (cacheMarketDeltaMini != null)
                for (int idx = 0; idx < cacheMarketDeltaMini.Length; idx++)
                    if (cacheMarketDeltaMini[idx].AskIncCount == askIncCount && cacheMarketDeltaMini[idx].BidDecCount == bidDecCount && cacheMarketDeltaMini[idx].CotBand == cotBand && cacheMarketDeltaMini[idx].EqualsInput(input))
                        return cacheMarketDeltaMini[idx];

            lock (checkMarketDeltaMini)
            {
                checkMarketDeltaMini.AskIncCount = askIncCount;
                askIncCount = checkMarketDeltaMini.AskIncCount;
                checkMarketDeltaMini.BidDecCount = bidDecCount;
                bidDecCount = checkMarketDeltaMini.BidDecCount;
                checkMarketDeltaMini.CotBand = cotBand;
                cotBand = checkMarketDeltaMini.CotBand;

                if (cacheMarketDeltaMini != null)
                    for (int idx = 0; idx < cacheMarketDeltaMini.Length; idx++)
                        if (cacheMarketDeltaMini[idx].AskIncCount == askIncCount && cacheMarketDeltaMini[idx].BidDecCount == bidDecCount && cacheMarketDeltaMini[idx].CotBand == cotBand && cacheMarketDeltaMini[idx].EqualsInput(input))
                            return cacheMarketDeltaMini[idx];

                MarketDeltaMini indicator = new MarketDeltaMini();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.AskIncCount = askIncCount;
                indicator.BidDecCount = bidDecCount;
                indicator.CotBand = cotBand;
                Indicators.Add(indicator);
                indicator.SetUp();

                MarketDeltaMini[] tmp = new MarketDeltaMini[cacheMarketDeltaMini == null ? 1 : cacheMarketDeltaMini.Length + 1];
                if (cacheMarketDeltaMini != null)
                    cacheMarketDeltaMini.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheMarketDeltaMini = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftGhostiBlock noftGhostiBlock(int askThreshold, int bidThreshold, Color blockBuyBackground, Color blockBuyBorder, int blockBuyOpacity, int blockFrame, int blockMinBuySize, int blockMinSellSize, Color blockSellBackground, Color blockSellBorder, int blockSellOpacity, string blockSide, int blockZoneHeight, int blockZoneTimeoutValue, string blockZoneTimeoutType, int blockZoneWidth, int minStackSize, string signalSound, Color stackedBuyBackground, Color stackedBuyBorder, int stackedBuyOpacity, int stackedFrame, int stackedLevels, Color stackedSellBackground, Color stackedSellBorder, int stackedSellOpacity, string stackedSide, string stackedSound, int stackedTimeoutValue, string stackedTimeoutType)
        {
            return _indicator.noftGhostiBlock(Input, askThreshold, bidThreshold, blockBuyBackground, blockBuyBorder, blockBuyOpacity, blockFrame, blockMinBuySize, blockMinSellSize, blockSellBackground, blockSellBorder, blockSellOpacity, blockSide, blockZoneHeight, blockZoneTimeoutValue, blockZoneTimeoutType, blockZoneWidth, minStackSize, signalSound, stackedBuyBackground, stackedBuyBorder, stackedBuyOpacity, stackedFrame, stackedLevels, stackedSellBackground, stackedSellBorder, stackedSellOpacity, stackedSide, stackedSound, stackedTimeoutValue, stackedTimeoutType);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftGhostiBlock noftGhostiBlock(Data.IDataSeries input, int askThreshold, int bidThreshold, Color blockBuyBackground, Color blockBuyBorder, int blockBuyOpacity, int blockFrame, int blockMinBuySize, int blockMinSellSize, Color blockSellBackground, Color blockSellBorder, int blockSellOpacity, string blockSide, int blockZoneHeight, int blockZoneTimeoutValue, string blockZoneTimeoutType, int blockZoneWidth, int minStackSize, string signalSound, Color stackedBuyBackground, Color stackedBuyBorder, int stackedBuyOpacity, int stackedFrame, int stackedLevels, Color stackedSellBackground, Color stackedSellBorder, int stackedSellOpacity, string stackedSide, string stackedSound, int stackedTimeoutValue, string stackedTimeoutType)
        {
            return _indicator.noftGhostiBlock(input, askThreshold, bidThreshold, blockBuyBackground, blockBuyBorder, blockBuyOpacity, blockFrame, blockMinBuySize, blockMinSellSize, blockSellBackground, blockSellBorder, blockSellOpacity, blockSide, blockZoneHeight, blockZoneTimeoutValue, blockZoneTimeoutType, blockZoneWidth, minStackSize, signalSound, stackedBuyBackground, stackedBuyBorder, stackedBuyOpacity, stackedFrame, stackedLevels, stackedSellBackground, stackedSellBorder, stackedSellOpacity, stackedSide, stackedSound, stackedTimeoutValue, stackedTimeoutType);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.MarketDeltaMini MarketDeltaMini(int askIncCount, int bidDecCount, int cotBand)
        {
            return _indicator.MarketDeltaMini(Input, askIncCount, bidDecCount, cotBand);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.MarketDeltaMini MarketDeltaMini(Data.IDataSeries input, int askIncCount, int bidDecCount, int cotBand)
        {
            return _indicator.MarketDeltaMini(input, askIncCount, bidDecCount, cotBand);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftGhostiBlock noftGhostiBlock(int askThreshold, int bidThreshold, Color blockBuyBackground, Color blockBuyBorder, int blockBuyOpacity, int blockFrame, int blockMinBuySize, int blockMinSellSize, Color blockSellBackground, Color blockSellBorder, int blockSellOpacity, string blockSide, int blockZoneHeight, int blockZoneTimeoutValue, string blockZoneTimeoutType, int blockZoneWidth, int minStackSize, string signalSound, Color stackedBuyBackground, Color stackedBuyBorder, int stackedBuyOpacity, int stackedFrame, int stackedLevels, Color stackedSellBackground, Color stackedSellBorder, int stackedSellOpacity, string stackedSide, string stackedSound, int stackedTimeoutValue, string stackedTimeoutType)
        {
            return _indicator.noftGhostiBlock(Input, askThreshold, bidThreshold, blockBuyBackground, blockBuyBorder, blockBuyOpacity, blockFrame, blockMinBuySize, blockMinSellSize, blockSellBackground, blockSellBorder, blockSellOpacity, blockSide, blockZoneHeight, blockZoneTimeoutValue, blockZoneTimeoutType, blockZoneWidth, minStackSize, signalSound, stackedBuyBackground, stackedBuyBorder, stackedBuyOpacity, stackedFrame, stackedLevels, stackedSellBackground, stackedSellBorder, stackedSellOpacity, stackedSide, stackedSound, stackedTimeoutValue, stackedTimeoutType);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftGhostiBlock noftGhostiBlock(Data.IDataSeries input, int askThreshold, int bidThreshold, Color blockBuyBackground, Color blockBuyBorder, int blockBuyOpacity, int blockFrame, int blockMinBuySize, int blockMinSellSize, Color blockSellBackground, Color blockSellBorder, int blockSellOpacity, string blockSide, int blockZoneHeight, int blockZoneTimeoutValue, string blockZoneTimeoutType, int blockZoneWidth, int minStackSize, string signalSound, Color stackedBuyBackground, Color stackedBuyBorder, int stackedBuyOpacity, int stackedFrame, int stackedLevels, Color stackedSellBackground, Color stackedSellBorder, int stackedSellOpacity, string stackedSide, string stackedSound, int stackedTimeoutValue, string stackedTimeoutType)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.noftGhostiBlock(input, askThreshold, bidThreshold, blockBuyBackground, blockBuyBorder, blockBuyOpacity, blockFrame, blockMinBuySize, blockMinSellSize, blockSellBackground, blockSellBorder, blockSellOpacity, blockSide, blockZoneHeight, blockZoneTimeoutValue, blockZoneTimeoutType, blockZoneWidth, minStackSize, signalSound, stackedBuyBackground, stackedBuyBorder, stackedBuyOpacity, stackedFrame, stackedLevels, stackedSellBackground, stackedSellBorder, stackedSellOpacity, stackedSide, stackedSound, stackedTimeoutValue, stackedTimeoutType);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.MarketDeltaMini MarketDeltaMini(int askIncCount, int bidDecCount, int cotBand)
        {
            return _indicator.MarketDeltaMini(Input, askIncCount, bidDecCount, cotBand);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.MarketDeltaMini MarketDeltaMini(Data.IDataSeries input, int askIncCount, int bidDecCount, int cotBand)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.MarketDeltaMini(input, askIncCount, bidDecCount, cotBand);
        }
    }
}
#endregion
