//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private noftHomeWorkLevelAlert[] cachenoftHomeWorkLevelAlert = null;

        private static noftHomeWorkLevelAlert checknoftHomeWorkLevelAlert = new noftHomeWorkLevelAlert();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftHomeWorkLevelAlert noftHomeWorkLevelAlert(int alertSensitivity, string defaultLabel, DashStyle lineDash, int lineWidth, string positionMode, string sound, Color textBackColor, int textBackOpacity)
        {
            return noftHomeWorkLevelAlert(Input, alertSensitivity, defaultLabel, lineDash, lineWidth, positionMode, sound, textBackColor, textBackOpacity);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftHomeWorkLevelAlert noftHomeWorkLevelAlert(Data.IDataSeries input, int alertSensitivity, string defaultLabel, DashStyle lineDash, int lineWidth, string positionMode, string sound, Color textBackColor, int textBackOpacity)
        {
            if (cachenoftHomeWorkLevelAlert != null)
                for (int idx = 0; idx < cachenoftHomeWorkLevelAlert.Length; idx++)
                    if (cachenoftHomeWorkLevelAlert[idx].AlertSensitivity == alertSensitivity && cachenoftHomeWorkLevelAlert[idx].DefaultLabel == defaultLabel && cachenoftHomeWorkLevelAlert[idx].LineDash == lineDash && cachenoftHomeWorkLevelAlert[idx].LineWidth == lineWidth && cachenoftHomeWorkLevelAlert[idx].PositionMode == positionMode && cachenoftHomeWorkLevelAlert[idx].Sound == sound && cachenoftHomeWorkLevelAlert[idx].TextBackColor == textBackColor && cachenoftHomeWorkLevelAlert[idx].TextBackOpacity == textBackOpacity && cachenoftHomeWorkLevelAlert[idx].EqualsInput(input))
                        return cachenoftHomeWorkLevelAlert[idx];

            lock (checknoftHomeWorkLevelAlert)
            {
                checknoftHomeWorkLevelAlert.AlertSensitivity = alertSensitivity;
                alertSensitivity = checknoftHomeWorkLevelAlert.AlertSensitivity;
                checknoftHomeWorkLevelAlert.DefaultLabel = defaultLabel;
                defaultLabel = checknoftHomeWorkLevelAlert.DefaultLabel;
                checknoftHomeWorkLevelAlert.LineDash = lineDash;
                lineDash = checknoftHomeWorkLevelAlert.LineDash;
                checknoftHomeWorkLevelAlert.LineWidth = lineWidth;
                lineWidth = checknoftHomeWorkLevelAlert.LineWidth;
                checknoftHomeWorkLevelAlert.PositionMode = positionMode;
                positionMode = checknoftHomeWorkLevelAlert.PositionMode;
                checknoftHomeWorkLevelAlert.Sound = sound;
                sound = checknoftHomeWorkLevelAlert.Sound;
                checknoftHomeWorkLevelAlert.TextBackColor = textBackColor;
                textBackColor = checknoftHomeWorkLevelAlert.TextBackColor;
                checknoftHomeWorkLevelAlert.TextBackOpacity = textBackOpacity;
                textBackOpacity = checknoftHomeWorkLevelAlert.TextBackOpacity;

                if (cachenoftHomeWorkLevelAlert != null)
                    for (int idx = 0; idx < cachenoftHomeWorkLevelAlert.Length; idx++)
                        if (cachenoftHomeWorkLevelAlert[idx].AlertSensitivity == alertSensitivity && cachenoftHomeWorkLevelAlert[idx].DefaultLabel == defaultLabel && cachenoftHomeWorkLevelAlert[idx].LineDash == lineDash && cachenoftHomeWorkLevelAlert[idx].LineWidth == lineWidth && cachenoftHomeWorkLevelAlert[idx].PositionMode == positionMode && cachenoftHomeWorkLevelAlert[idx].Sound == sound && cachenoftHomeWorkLevelAlert[idx].TextBackColor == textBackColor && cachenoftHomeWorkLevelAlert[idx].TextBackOpacity == textBackOpacity && cachenoftHomeWorkLevelAlert[idx].EqualsInput(input))
                            return cachenoftHomeWorkLevelAlert[idx];

                noftHomeWorkLevelAlert indicator = new noftHomeWorkLevelAlert();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.AlertSensitivity = alertSensitivity;
                indicator.DefaultLabel = defaultLabel;
                indicator.LineDash = lineDash;
                indicator.LineWidth = lineWidth;
                indicator.PositionMode = positionMode;
                indicator.Sound = sound;
                indicator.TextBackColor = textBackColor;
                indicator.TextBackOpacity = textBackOpacity;
                Indicators.Add(indicator);
                indicator.SetUp();

                noftHomeWorkLevelAlert[] tmp = new noftHomeWorkLevelAlert[cachenoftHomeWorkLevelAlert == null ? 1 : cachenoftHomeWorkLevelAlert.Length + 1];
                if (cachenoftHomeWorkLevelAlert != null)
                    cachenoftHomeWorkLevelAlert.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachenoftHomeWorkLevelAlert = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftHomeWorkLevelAlert noftHomeWorkLevelAlert(int alertSensitivity, string defaultLabel, DashStyle lineDash, int lineWidth, string positionMode, string sound, Color textBackColor, int textBackOpacity)
        {
            return _indicator.noftHomeWorkLevelAlert(Input, alertSensitivity, defaultLabel, lineDash, lineWidth, positionMode, sound, textBackColor, textBackOpacity);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftHomeWorkLevelAlert noftHomeWorkLevelAlert(Data.IDataSeries input, int alertSensitivity, string defaultLabel, DashStyle lineDash, int lineWidth, string positionMode, string sound, Color textBackColor, int textBackOpacity)
        {
            return _indicator.noftHomeWorkLevelAlert(input, alertSensitivity, defaultLabel, lineDash, lineWidth, positionMode, sound, textBackColor, textBackOpacity);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftHomeWorkLevelAlert noftHomeWorkLevelAlert(int alertSensitivity, string defaultLabel, DashStyle lineDash, int lineWidth, string positionMode, string sound, Color textBackColor, int textBackOpacity)
        {
            return _indicator.noftHomeWorkLevelAlert(Input, alertSensitivity, defaultLabel, lineDash, lineWidth, positionMode, sound, textBackColor, textBackOpacity);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftHomeWorkLevelAlert noftHomeWorkLevelAlert(Data.IDataSeries input, int alertSensitivity, string defaultLabel, DashStyle lineDash, int lineWidth, string positionMode, string sound, Color textBackColor, int textBackOpacity)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.noftHomeWorkLevelAlert(input, alertSensitivity, defaultLabel, lineDash, lineWidth, positionMode, sound, textBackColor, textBackOpacity);
        }
    }
}
#endregion
