//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private noftIMFTracker[] cachenoftIMFTracker = null;
        private MarketDeltaCore[] cacheMarketDeltaCore = null;

        private static noftIMFTracker checknoftIMFTracker = new noftIMFTracker();
        private static MarketDeltaCore checkMarketDeltaCore = new MarketDeltaCore();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftIMFTracker noftIMFTracker(Font aBFont, string accountName, int askThreshold, int bidThreshold, string calculateWith, bool drawStartStopLine, Plot endLine, Font font, Color longPressure, string mode, string panelPosition, int panelWidth, Color pressureBarTextColor, Color shortPressure, bool showBuySellValues, int sizeFilter, bool startCalculationOnTrade, Plot startLine, int trackStart, int trackStop)
        {
            return noftIMFTracker(Input, aBFont, accountName, askThreshold, bidThreshold, calculateWith, drawStartStopLine, endLine, font, longPressure, mode, panelPosition, panelWidth, pressureBarTextColor, shortPressure, showBuySellValues, sizeFilter, startCalculationOnTrade, startLine, trackStart, trackStop);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftIMFTracker noftIMFTracker(Data.IDataSeries input, Font aBFont, string accountName, int askThreshold, int bidThreshold, string calculateWith, bool drawStartStopLine, Plot endLine, Font font, Color longPressure, string mode, string panelPosition, int panelWidth, Color pressureBarTextColor, Color shortPressure, bool showBuySellValues, int sizeFilter, bool startCalculationOnTrade, Plot startLine, int trackStart, int trackStop)
        {
            if (cachenoftIMFTracker != null)
                for (int idx = 0; idx < cachenoftIMFTracker.Length; idx++)
                    if (cachenoftIMFTracker[idx].ABFont == aBFont && cachenoftIMFTracker[idx].AccountName == accountName && cachenoftIMFTracker[idx].AskThreshold == askThreshold && cachenoftIMFTracker[idx].BidThreshold == bidThreshold && cachenoftIMFTracker[idx].CalculateWith == calculateWith && cachenoftIMFTracker[idx].DrawStartStopLine == drawStartStopLine && cachenoftIMFTracker[idx].EndLine == endLine && cachenoftIMFTracker[idx].Font == font && cachenoftIMFTracker[idx].LongPressure == longPressure && cachenoftIMFTracker[idx].Mode == mode && cachenoftIMFTracker[idx].PanelPosition == panelPosition && cachenoftIMFTracker[idx].PanelWidth == panelWidth && cachenoftIMFTracker[idx].PressureBarTextColor == pressureBarTextColor && cachenoftIMFTracker[idx].ShortPressure == shortPressure && cachenoftIMFTracker[idx].ShowBuySellValues == showBuySellValues && cachenoftIMFTracker[idx].SizeFilter == sizeFilter && cachenoftIMFTracker[idx].StartCalculationOnTrade == startCalculationOnTrade && cachenoftIMFTracker[idx].StartLine == startLine && cachenoftIMFTracker[idx].TrackStart == trackStart && cachenoftIMFTracker[idx].TrackStop == trackStop && cachenoftIMFTracker[idx].EqualsInput(input))
                        return cachenoftIMFTracker[idx];

            lock (checknoftIMFTracker)
            {
                checknoftIMFTracker.ABFont = aBFont;
                aBFont = checknoftIMFTracker.ABFont;
                checknoftIMFTracker.AccountName = accountName;
                accountName = checknoftIMFTracker.AccountName;
                checknoftIMFTracker.AskThreshold = askThreshold;
                askThreshold = checknoftIMFTracker.AskThreshold;
                checknoftIMFTracker.BidThreshold = bidThreshold;
                bidThreshold = checknoftIMFTracker.BidThreshold;
                checknoftIMFTracker.CalculateWith = calculateWith;
                calculateWith = checknoftIMFTracker.CalculateWith;
                checknoftIMFTracker.DrawStartStopLine = drawStartStopLine;
                drawStartStopLine = checknoftIMFTracker.DrawStartStopLine;
                checknoftIMFTracker.EndLine = endLine;
                endLine = checknoftIMFTracker.EndLine;
                checknoftIMFTracker.Font = font;
                font = checknoftIMFTracker.Font;
                checknoftIMFTracker.LongPressure = longPressure;
                longPressure = checknoftIMFTracker.LongPressure;
                checknoftIMFTracker.Mode = mode;
                mode = checknoftIMFTracker.Mode;
                checknoftIMFTracker.PanelPosition = panelPosition;
                panelPosition = checknoftIMFTracker.PanelPosition;
                checknoftIMFTracker.PanelWidth = panelWidth;
                panelWidth = checknoftIMFTracker.PanelWidth;
                checknoftIMFTracker.PressureBarTextColor = pressureBarTextColor;
                pressureBarTextColor = checknoftIMFTracker.PressureBarTextColor;
                checknoftIMFTracker.ShortPressure = shortPressure;
                shortPressure = checknoftIMFTracker.ShortPressure;
                checknoftIMFTracker.ShowBuySellValues = showBuySellValues;
                showBuySellValues = checknoftIMFTracker.ShowBuySellValues;
                checknoftIMFTracker.SizeFilter = sizeFilter;
                sizeFilter = checknoftIMFTracker.SizeFilter;
                checknoftIMFTracker.StartCalculationOnTrade = startCalculationOnTrade;
                startCalculationOnTrade = checknoftIMFTracker.StartCalculationOnTrade;
                checknoftIMFTracker.StartLine = startLine;
                startLine = checknoftIMFTracker.StartLine;
                checknoftIMFTracker.TrackStart = trackStart;
                trackStart = checknoftIMFTracker.TrackStart;
                checknoftIMFTracker.TrackStop = trackStop;
                trackStop = checknoftIMFTracker.TrackStop;

                if (cachenoftIMFTracker != null)
                    for (int idx = 0; idx < cachenoftIMFTracker.Length; idx++)
                        if (cachenoftIMFTracker[idx].ABFont == aBFont && cachenoftIMFTracker[idx].AccountName == accountName && cachenoftIMFTracker[idx].AskThreshold == askThreshold && cachenoftIMFTracker[idx].BidThreshold == bidThreshold && cachenoftIMFTracker[idx].CalculateWith == calculateWith && cachenoftIMFTracker[idx].DrawStartStopLine == drawStartStopLine && cachenoftIMFTracker[idx].EndLine == endLine && cachenoftIMFTracker[idx].Font == font && cachenoftIMFTracker[idx].LongPressure == longPressure && cachenoftIMFTracker[idx].Mode == mode && cachenoftIMFTracker[idx].PanelPosition == panelPosition && cachenoftIMFTracker[idx].PanelWidth == panelWidth && cachenoftIMFTracker[idx].PressureBarTextColor == pressureBarTextColor && cachenoftIMFTracker[idx].ShortPressure == shortPressure && cachenoftIMFTracker[idx].ShowBuySellValues == showBuySellValues && cachenoftIMFTracker[idx].SizeFilter == sizeFilter && cachenoftIMFTracker[idx].StartCalculationOnTrade == startCalculationOnTrade && cachenoftIMFTracker[idx].StartLine == startLine && cachenoftIMFTracker[idx].TrackStart == trackStart && cachenoftIMFTracker[idx].TrackStop == trackStop && cachenoftIMFTracker[idx].EqualsInput(input))
                            return cachenoftIMFTracker[idx];

                noftIMFTracker indicator = new noftIMFTracker();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.ABFont = aBFont;
                indicator.AccountName = accountName;
                indicator.AskThreshold = askThreshold;
                indicator.BidThreshold = bidThreshold;
                indicator.CalculateWith = calculateWith;
                indicator.DrawStartStopLine = drawStartStopLine;
                indicator.EndLine = endLine;
                indicator.Font = font;
                indicator.LongPressure = longPressure;
                indicator.Mode = mode;
                indicator.PanelPosition = panelPosition;
                indicator.PanelWidth = panelWidth;
                indicator.PressureBarTextColor = pressureBarTextColor;
                indicator.ShortPressure = shortPressure;
                indicator.ShowBuySellValues = showBuySellValues;
                indicator.SizeFilter = sizeFilter;
                indicator.StartCalculationOnTrade = startCalculationOnTrade;
                indicator.StartLine = startLine;
                indicator.TrackStart = trackStart;
                indicator.TrackStop = trackStop;
                Indicators.Add(indicator);
                indicator.SetUp();

                noftIMFTracker[] tmp = new noftIMFTracker[cachenoftIMFTracker == null ? 1 : cachenoftIMFTracker.Length + 1];
                if (cachenoftIMFTracker != null)
                    cachenoftIMFTracker.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachenoftIMFTracker = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public MarketDeltaCore MarketDeltaCore(int askIncCount, int bidDecCount, int cotBand)
        {
            return MarketDeltaCore(Input, askIncCount, bidDecCount, cotBand);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public MarketDeltaCore MarketDeltaCore(Data.IDataSeries input, int askIncCount, int bidDecCount, int cotBand)
        {
            if (cacheMarketDeltaCore != null)
                for (int idx = 0; idx < cacheMarketDeltaCore.Length; idx++)
                    if (cacheMarketDeltaCore[idx].AskIncCount == askIncCount && cacheMarketDeltaCore[idx].BidDecCount == bidDecCount && cacheMarketDeltaCore[idx].CotBand == cotBand && cacheMarketDeltaCore[idx].EqualsInput(input))
                        return cacheMarketDeltaCore[idx];

            lock (checkMarketDeltaCore)
            {
                checkMarketDeltaCore.AskIncCount = askIncCount;
                askIncCount = checkMarketDeltaCore.AskIncCount;
                checkMarketDeltaCore.BidDecCount = bidDecCount;
                bidDecCount = checkMarketDeltaCore.BidDecCount;
                checkMarketDeltaCore.CotBand = cotBand;
                cotBand = checkMarketDeltaCore.CotBand;

                if (cacheMarketDeltaCore != null)
                    for (int idx = 0; idx < cacheMarketDeltaCore.Length; idx++)
                        if (cacheMarketDeltaCore[idx].AskIncCount == askIncCount && cacheMarketDeltaCore[idx].BidDecCount == bidDecCount && cacheMarketDeltaCore[idx].CotBand == cotBand && cacheMarketDeltaCore[idx].EqualsInput(input))
                            return cacheMarketDeltaCore[idx];

                MarketDeltaCore indicator = new MarketDeltaCore();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.AskIncCount = askIncCount;
                indicator.BidDecCount = bidDecCount;
                indicator.CotBand = cotBand;
                Indicators.Add(indicator);
                indicator.SetUp();

                MarketDeltaCore[] tmp = new MarketDeltaCore[cacheMarketDeltaCore == null ? 1 : cacheMarketDeltaCore.Length + 1];
                if (cacheMarketDeltaCore != null)
                    cacheMarketDeltaCore.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheMarketDeltaCore = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftIMFTracker noftIMFTracker(Font aBFont, string accountName, int askThreshold, int bidThreshold, string calculateWith, bool drawStartStopLine, Plot endLine, Font font, Color longPressure, string mode, string panelPosition, int panelWidth, Color pressureBarTextColor, Color shortPressure, bool showBuySellValues, int sizeFilter, bool startCalculationOnTrade, Plot startLine, int trackStart, int trackStop)
        {
            return _indicator.noftIMFTracker(Input, aBFont, accountName, askThreshold, bidThreshold, calculateWith, drawStartStopLine, endLine, font, longPressure, mode, panelPosition, panelWidth, pressureBarTextColor, shortPressure, showBuySellValues, sizeFilter, startCalculationOnTrade, startLine, trackStart, trackStop);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftIMFTracker noftIMFTracker(Data.IDataSeries input, Font aBFont, string accountName, int askThreshold, int bidThreshold, string calculateWith, bool drawStartStopLine, Plot endLine, Font font, Color longPressure, string mode, string panelPosition, int panelWidth, Color pressureBarTextColor, Color shortPressure, bool showBuySellValues, int sizeFilter, bool startCalculationOnTrade, Plot startLine, int trackStart, int trackStop)
        {
            return _indicator.noftIMFTracker(input, aBFont, accountName, askThreshold, bidThreshold, calculateWith, drawStartStopLine, endLine, font, longPressure, mode, panelPosition, panelWidth, pressureBarTextColor, shortPressure, showBuySellValues, sizeFilter, startCalculationOnTrade, startLine, trackStart, trackStop);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.MarketDeltaCore MarketDeltaCore(int askIncCount, int bidDecCount, int cotBand)
        {
            return _indicator.MarketDeltaCore(Input, askIncCount, bidDecCount, cotBand);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.MarketDeltaCore MarketDeltaCore(Data.IDataSeries input, int askIncCount, int bidDecCount, int cotBand)
        {
            return _indicator.MarketDeltaCore(input, askIncCount, bidDecCount, cotBand);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftIMFTracker noftIMFTracker(Font aBFont, string accountName, int askThreshold, int bidThreshold, string calculateWith, bool drawStartStopLine, Plot endLine, Font font, Color longPressure, string mode, string panelPosition, int panelWidth, Color pressureBarTextColor, Color shortPressure, bool showBuySellValues, int sizeFilter, bool startCalculationOnTrade, Plot startLine, int trackStart, int trackStop)
        {
            return _indicator.noftIMFTracker(Input, aBFont, accountName, askThreshold, bidThreshold, calculateWith, drawStartStopLine, endLine, font, longPressure, mode, panelPosition, panelWidth, pressureBarTextColor, shortPressure, showBuySellValues, sizeFilter, startCalculationOnTrade, startLine, trackStart, trackStop);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftIMFTracker noftIMFTracker(Data.IDataSeries input, Font aBFont, string accountName, int askThreshold, int bidThreshold, string calculateWith, bool drawStartStopLine, Plot endLine, Font font, Color longPressure, string mode, string panelPosition, int panelWidth, Color pressureBarTextColor, Color shortPressure, bool showBuySellValues, int sizeFilter, bool startCalculationOnTrade, Plot startLine, int trackStart, int trackStop)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.noftIMFTracker(input, aBFont, accountName, askThreshold, bidThreshold, calculateWith, drawStartStopLine, endLine, font, longPressure, mode, panelPosition, panelWidth, pressureBarTextColor, shortPressure, showBuySellValues, sizeFilter, startCalculationOnTrade, startLine, trackStart, trackStop);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.MarketDeltaCore MarketDeltaCore(int askIncCount, int bidDecCount, int cotBand)
        {
            return _indicator.MarketDeltaCore(Input, askIncCount, bidDecCount, cotBand);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.MarketDeltaCore MarketDeltaCore(Data.IDataSeries input, int askIncCount, int bidDecCount, int cotBand)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.MarketDeltaCore(input, askIncCount, bidDecCount, cotBand);
        }
    }
}
#endregion
