//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private noftInventory[] cachenoftInventory = null;

        private static noftInventory checknoftInventory = new noftInventory();

        /// <summary>
        /// Empty placeholder indicator for creating plots in NinjaScript Strategies
        /// </summary>
        /// <returns></returns>
        public noftInventory noftInventory(int sessionStart)
        {
            return noftInventory(Input, sessionStart);
        }

        /// <summary>
        /// Empty placeholder indicator for creating plots in NinjaScript Strategies
        /// </summary>
        /// <returns></returns>
        public noftInventory noftInventory(Data.IDataSeries input, int sessionStart)
        {
            if (cachenoftInventory != null)
                for (int idx = 0; idx < cachenoftInventory.Length; idx++)
                    if (cachenoftInventory[idx].SessionStart == sessionStart && cachenoftInventory[idx].EqualsInput(input))
                        return cachenoftInventory[idx];

            lock (checknoftInventory)
            {
                checknoftInventory.SessionStart = sessionStart;
                sessionStart = checknoftInventory.SessionStart;

                if (cachenoftInventory != null)
                    for (int idx = 0; idx < cachenoftInventory.Length; idx++)
                        if (cachenoftInventory[idx].SessionStart == sessionStart && cachenoftInventory[idx].EqualsInput(input))
                            return cachenoftInventory[idx];

                noftInventory indicator = new noftInventory();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.SessionStart = sessionStart;
                Indicators.Add(indicator);
                indicator.SetUp();

                noftInventory[] tmp = new noftInventory[cachenoftInventory == null ? 1 : cachenoftInventory.Length + 1];
                if (cachenoftInventory != null)
                    cachenoftInventory.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachenoftInventory = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Empty placeholder indicator for creating plots in NinjaScript Strategies
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftInventory noftInventory(int sessionStart)
        {
            return _indicator.noftInventory(Input, sessionStart);
        }

        /// <summary>
        /// Empty placeholder indicator for creating plots in NinjaScript Strategies
        /// </summary>
        /// <returns></returns>
        public Indicator.noftInventory noftInventory(Data.IDataSeries input, int sessionStart)
        {
            return _indicator.noftInventory(input, sessionStart);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Empty placeholder indicator for creating plots in NinjaScript Strategies
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftInventory noftInventory(int sessionStart)
        {
            return _indicator.noftInventory(Input, sessionStart);
        }

        /// <summary>
        /// Empty placeholder indicator for creating plots in NinjaScript Strategies
        /// </summary>
        /// <returns></returns>
        public Indicator.noftInventory noftInventory(Data.IDataSeries input, int sessionStart)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.noftInventory(input, sessionStart);
        }
    }
}
#endregion
