//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private noftOrderFlowDeltaHistogram[] cachenoftOrderFlowDeltaHistogram = null;
        private noftOrderFlowSequenceTracker[] cachenoftOrderFlowSequenceTracker = null;
        private noftDeltaAverage[] cachenoftDeltaAverage = null;

        private static noftOrderFlowDeltaHistogram checknoftOrderFlowDeltaHistogram = new noftOrderFlowDeltaHistogram();
        private static noftOrderFlowSequenceTracker checknoftOrderFlowSequenceTracker = new noftOrderFlowSequenceTracker();
        private static noftDeltaAverage checknoftDeltaAverage = new noftDeltaAverage();

        /// <summary>
        /// Empty placeholder indicator for creating plots in NinjaScript Strategies
        /// </summary>
        /// <returns></returns>
        public noftOrderFlowDeltaHistogram noftOrderFlowDeltaHistogram(int lowerDeltaLimit, string lowerDeltaSound, bool markLimitBreak, int upperDeltaLimit, string upperDeltaSound)
        {
            return noftOrderFlowDeltaHistogram(Input, lowerDeltaLimit, lowerDeltaSound, markLimitBreak, upperDeltaLimit, upperDeltaSound);
        }

        /// <summary>
        /// Empty placeholder indicator for creating plots in NinjaScript Strategies
        /// </summary>
        /// <returns></returns>
        public noftOrderFlowDeltaHistogram noftOrderFlowDeltaHistogram(Data.IDataSeries input, int lowerDeltaLimit, string lowerDeltaSound, bool markLimitBreak, int upperDeltaLimit, string upperDeltaSound)
        {
            if (cachenoftOrderFlowDeltaHistogram != null)
                for (int idx = 0; idx < cachenoftOrderFlowDeltaHistogram.Length; idx++)
                    if (cachenoftOrderFlowDeltaHistogram[idx].LowerDeltaLimit == lowerDeltaLimit && cachenoftOrderFlowDeltaHistogram[idx].LowerDeltaSound == lowerDeltaSound && cachenoftOrderFlowDeltaHistogram[idx].MarkLimitBreak == markLimitBreak && cachenoftOrderFlowDeltaHistogram[idx].UpperDeltaLimit == upperDeltaLimit && cachenoftOrderFlowDeltaHistogram[idx].UpperDeltaSound == upperDeltaSound && cachenoftOrderFlowDeltaHistogram[idx].EqualsInput(input))
                        return cachenoftOrderFlowDeltaHistogram[idx];

            lock (checknoftOrderFlowDeltaHistogram)
            {
                checknoftOrderFlowDeltaHistogram.LowerDeltaLimit = lowerDeltaLimit;
                lowerDeltaLimit = checknoftOrderFlowDeltaHistogram.LowerDeltaLimit;
                checknoftOrderFlowDeltaHistogram.LowerDeltaSound = lowerDeltaSound;
                lowerDeltaSound = checknoftOrderFlowDeltaHistogram.LowerDeltaSound;
                checknoftOrderFlowDeltaHistogram.MarkLimitBreak = markLimitBreak;
                markLimitBreak = checknoftOrderFlowDeltaHistogram.MarkLimitBreak;
                checknoftOrderFlowDeltaHistogram.UpperDeltaLimit = upperDeltaLimit;
                upperDeltaLimit = checknoftOrderFlowDeltaHistogram.UpperDeltaLimit;
                checknoftOrderFlowDeltaHistogram.UpperDeltaSound = upperDeltaSound;
                upperDeltaSound = checknoftOrderFlowDeltaHistogram.UpperDeltaSound;

                if (cachenoftOrderFlowDeltaHistogram != null)
                    for (int idx = 0; idx < cachenoftOrderFlowDeltaHistogram.Length; idx++)
                        if (cachenoftOrderFlowDeltaHistogram[idx].LowerDeltaLimit == lowerDeltaLimit && cachenoftOrderFlowDeltaHistogram[idx].LowerDeltaSound == lowerDeltaSound && cachenoftOrderFlowDeltaHistogram[idx].MarkLimitBreak == markLimitBreak && cachenoftOrderFlowDeltaHistogram[idx].UpperDeltaLimit == upperDeltaLimit && cachenoftOrderFlowDeltaHistogram[idx].UpperDeltaSound == upperDeltaSound && cachenoftOrderFlowDeltaHistogram[idx].EqualsInput(input))
                            return cachenoftOrderFlowDeltaHistogram[idx];

                noftOrderFlowDeltaHistogram indicator = new noftOrderFlowDeltaHistogram();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.LowerDeltaLimit = lowerDeltaLimit;
                indicator.LowerDeltaSound = lowerDeltaSound;
                indicator.MarkLimitBreak = markLimitBreak;
                indicator.UpperDeltaLimit = upperDeltaLimit;
                indicator.UpperDeltaSound = upperDeltaSound;
                Indicators.Add(indicator);
                indicator.SetUp();

                noftOrderFlowDeltaHistogram[] tmp = new noftOrderFlowDeltaHistogram[cachenoftOrderFlowDeltaHistogram == null ? 1 : cachenoftOrderFlowDeltaHistogram.Length + 1];
                if (cachenoftOrderFlowDeltaHistogram != null)
                    cachenoftOrderFlowDeltaHistogram.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachenoftOrderFlowDeltaHistogram = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public noftOrderFlowSequenceTracker noftOrderFlowSequenceTracker(int askIncreaseCount, int breakOutCotPosition, string calculation, bool currentBarRule, bool hHLLRule, int increaseCotPosition, int longBidDeclineCount, int longDeclineCotPosition, string longSound, bool previousBarRule, Color reverseFontColor, Color reverseLong, Color reverseShort, string shortSound, bool showMarker)
        {
            return noftOrderFlowSequenceTracker(Input, askIncreaseCount, breakOutCotPosition, calculation, currentBarRule, hHLLRule, increaseCotPosition, longBidDeclineCount, longDeclineCotPosition, longSound, previousBarRule, reverseFontColor, reverseLong, reverseShort, shortSound, showMarker);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public noftOrderFlowSequenceTracker noftOrderFlowSequenceTracker(Data.IDataSeries input, int askIncreaseCount, int breakOutCotPosition, string calculation, bool currentBarRule, bool hHLLRule, int increaseCotPosition, int longBidDeclineCount, int longDeclineCotPosition, string longSound, bool previousBarRule, Color reverseFontColor, Color reverseLong, Color reverseShort, string shortSound, bool showMarker)
        {
            if (cachenoftOrderFlowSequenceTracker != null)
                for (int idx = 0; idx < cachenoftOrderFlowSequenceTracker.Length; idx++)
                    if (cachenoftOrderFlowSequenceTracker[idx].AskIncreaseCount == askIncreaseCount && cachenoftOrderFlowSequenceTracker[idx].BreakOutCotPosition == breakOutCotPosition && cachenoftOrderFlowSequenceTracker[idx].Calculation == calculation && cachenoftOrderFlowSequenceTracker[idx].CurrentBarRule == currentBarRule && cachenoftOrderFlowSequenceTracker[idx].HHLLRule == hHLLRule && cachenoftOrderFlowSequenceTracker[idx].IncreaseCotPosition == increaseCotPosition && cachenoftOrderFlowSequenceTracker[idx].LongBidDeclineCount == longBidDeclineCount && cachenoftOrderFlowSequenceTracker[idx].LongDeclineCotPosition == longDeclineCotPosition && cachenoftOrderFlowSequenceTracker[idx].LongSound == longSound && cachenoftOrderFlowSequenceTracker[idx].PreviousBarRule == previousBarRule && cachenoftOrderFlowSequenceTracker[idx].ReverseFontColor == reverseFontColor && cachenoftOrderFlowSequenceTracker[idx].ReverseLong == reverseLong && cachenoftOrderFlowSequenceTracker[idx].ReverseShort == reverseShort && cachenoftOrderFlowSequenceTracker[idx].ShortSound == shortSound && cachenoftOrderFlowSequenceTracker[idx].ShowMarker == showMarker && cachenoftOrderFlowSequenceTracker[idx].EqualsInput(input))
                        return cachenoftOrderFlowSequenceTracker[idx];

            lock (checknoftOrderFlowSequenceTracker)
            {
                checknoftOrderFlowSequenceTracker.AskIncreaseCount = askIncreaseCount;
                askIncreaseCount = checknoftOrderFlowSequenceTracker.AskIncreaseCount;
                checknoftOrderFlowSequenceTracker.BreakOutCotPosition = breakOutCotPosition;
                breakOutCotPosition = checknoftOrderFlowSequenceTracker.BreakOutCotPosition;
                checknoftOrderFlowSequenceTracker.Calculation = calculation;
                calculation = checknoftOrderFlowSequenceTracker.Calculation;
                checknoftOrderFlowSequenceTracker.CurrentBarRule = currentBarRule;
                currentBarRule = checknoftOrderFlowSequenceTracker.CurrentBarRule;
                checknoftOrderFlowSequenceTracker.HHLLRule = hHLLRule;
                hHLLRule = checknoftOrderFlowSequenceTracker.HHLLRule;
                checknoftOrderFlowSequenceTracker.IncreaseCotPosition = increaseCotPosition;
                increaseCotPosition = checknoftOrderFlowSequenceTracker.IncreaseCotPosition;
                checknoftOrderFlowSequenceTracker.LongBidDeclineCount = longBidDeclineCount;
                longBidDeclineCount = checknoftOrderFlowSequenceTracker.LongBidDeclineCount;
                checknoftOrderFlowSequenceTracker.LongDeclineCotPosition = longDeclineCotPosition;
                longDeclineCotPosition = checknoftOrderFlowSequenceTracker.LongDeclineCotPosition;
                checknoftOrderFlowSequenceTracker.LongSound = longSound;
                longSound = checknoftOrderFlowSequenceTracker.LongSound;
                checknoftOrderFlowSequenceTracker.PreviousBarRule = previousBarRule;
                previousBarRule = checknoftOrderFlowSequenceTracker.PreviousBarRule;
                checknoftOrderFlowSequenceTracker.ReverseFontColor = reverseFontColor;
                reverseFontColor = checknoftOrderFlowSequenceTracker.ReverseFontColor;
                checknoftOrderFlowSequenceTracker.ReverseLong = reverseLong;
                reverseLong = checknoftOrderFlowSequenceTracker.ReverseLong;
                checknoftOrderFlowSequenceTracker.ReverseShort = reverseShort;
                reverseShort = checknoftOrderFlowSequenceTracker.ReverseShort;
                checknoftOrderFlowSequenceTracker.ShortSound = shortSound;
                shortSound = checknoftOrderFlowSequenceTracker.ShortSound;
                checknoftOrderFlowSequenceTracker.ShowMarker = showMarker;
                showMarker = checknoftOrderFlowSequenceTracker.ShowMarker;

                if (cachenoftOrderFlowSequenceTracker != null)
                    for (int idx = 0; idx < cachenoftOrderFlowSequenceTracker.Length; idx++)
                        if (cachenoftOrderFlowSequenceTracker[idx].AskIncreaseCount == askIncreaseCount && cachenoftOrderFlowSequenceTracker[idx].BreakOutCotPosition == breakOutCotPosition && cachenoftOrderFlowSequenceTracker[idx].Calculation == calculation && cachenoftOrderFlowSequenceTracker[idx].CurrentBarRule == currentBarRule && cachenoftOrderFlowSequenceTracker[idx].HHLLRule == hHLLRule && cachenoftOrderFlowSequenceTracker[idx].IncreaseCotPosition == increaseCotPosition && cachenoftOrderFlowSequenceTracker[idx].LongBidDeclineCount == longBidDeclineCount && cachenoftOrderFlowSequenceTracker[idx].LongDeclineCotPosition == longDeclineCotPosition && cachenoftOrderFlowSequenceTracker[idx].LongSound == longSound && cachenoftOrderFlowSequenceTracker[idx].PreviousBarRule == previousBarRule && cachenoftOrderFlowSequenceTracker[idx].ReverseFontColor == reverseFontColor && cachenoftOrderFlowSequenceTracker[idx].ReverseLong == reverseLong && cachenoftOrderFlowSequenceTracker[idx].ReverseShort == reverseShort && cachenoftOrderFlowSequenceTracker[idx].ShortSound == shortSound && cachenoftOrderFlowSequenceTracker[idx].ShowMarker == showMarker && cachenoftOrderFlowSequenceTracker[idx].EqualsInput(input))
                            return cachenoftOrderFlowSequenceTracker[idx];

                noftOrderFlowSequenceTracker indicator = new noftOrderFlowSequenceTracker();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.AskIncreaseCount = askIncreaseCount;
                indicator.BreakOutCotPosition = breakOutCotPosition;
                indicator.Calculation = calculation;
                indicator.CurrentBarRule = currentBarRule;
                indicator.HHLLRule = hHLLRule;
                indicator.IncreaseCotPosition = increaseCotPosition;
                indicator.LongBidDeclineCount = longBidDeclineCount;
                indicator.LongDeclineCotPosition = longDeclineCotPosition;
                indicator.LongSound = longSound;
                indicator.PreviousBarRule = previousBarRule;
                indicator.ReverseFontColor = reverseFontColor;
                indicator.ReverseLong = reverseLong;
                indicator.ReverseShort = reverseShort;
                indicator.ShortSound = shortSound;
                indicator.ShowMarker = showMarker;
                Indicators.Add(indicator);
                indicator.SetUp();

                noftOrderFlowSequenceTracker[] tmp = new noftOrderFlowSequenceTracker[cachenoftOrderFlowSequenceTracker == null ? 1 : cachenoftOrderFlowSequenceTracker.Length + 1];
                if (cachenoftOrderFlowSequenceTracker != null)
                    cachenoftOrderFlowSequenceTracker.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachenoftOrderFlowSequenceTracker = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Empty placeholder indicator for creating plots in NinjaScript Strategies
        /// </summary>
        /// <returns></returns>
        public noftDeltaAverage noftDeltaAverage(Color deltaMaNegative, Color deltaMaPositive, int period)
        {
            return noftDeltaAverage(Input, deltaMaNegative, deltaMaPositive, period);
        }

        /// <summary>
        /// Empty placeholder indicator for creating plots in NinjaScript Strategies
        /// </summary>
        /// <returns></returns>
        public noftDeltaAverage noftDeltaAverage(Data.IDataSeries input, Color deltaMaNegative, Color deltaMaPositive, int period)
        {
            if (cachenoftDeltaAverage != null)
                for (int idx = 0; idx < cachenoftDeltaAverage.Length; idx++)
                    if (cachenoftDeltaAverage[idx].DeltaMaNegative == deltaMaNegative && cachenoftDeltaAverage[idx].DeltaMaPositive == deltaMaPositive && cachenoftDeltaAverage[idx].Period == period && cachenoftDeltaAverage[idx].EqualsInput(input))
                        return cachenoftDeltaAverage[idx];

            lock (checknoftDeltaAverage)
            {
                checknoftDeltaAverage.DeltaMaNegative = deltaMaNegative;
                deltaMaNegative = checknoftDeltaAverage.DeltaMaNegative;
                checknoftDeltaAverage.DeltaMaPositive = deltaMaPositive;
                deltaMaPositive = checknoftDeltaAverage.DeltaMaPositive;
                checknoftDeltaAverage.Period = period;
                period = checknoftDeltaAverage.Period;

                if (cachenoftDeltaAverage != null)
                    for (int idx = 0; idx < cachenoftDeltaAverage.Length; idx++)
                        if (cachenoftDeltaAverage[idx].DeltaMaNegative == deltaMaNegative && cachenoftDeltaAverage[idx].DeltaMaPositive == deltaMaPositive && cachenoftDeltaAverage[idx].Period == period && cachenoftDeltaAverage[idx].EqualsInput(input))
                            return cachenoftDeltaAverage[idx];

                noftDeltaAverage indicator = new noftDeltaAverage();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.DeltaMaNegative = deltaMaNegative;
                indicator.DeltaMaPositive = deltaMaPositive;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                noftDeltaAverage[] tmp = new noftDeltaAverage[cachenoftDeltaAverage == null ? 1 : cachenoftDeltaAverage.Length + 1];
                if (cachenoftDeltaAverage != null)
                    cachenoftDeltaAverage.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachenoftDeltaAverage = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Empty placeholder indicator for creating plots in NinjaScript Strategies
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftOrderFlowDeltaHistogram noftOrderFlowDeltaHistogram(int lowerDeltaLimit, string lowerDeltaSound, bool markLimitBreak, int upperDeltaLimit, string upperDeltaSound)
        {
            return _indicator.noftOrderFlowDeltaHistogram(Input, lowerDeltaLimit, lowerDeltaSound, markLimitBreak, upperDeltaLimit, upperDeltaSound);
        }

        /// <summary>
        /// Empty placeholder indicator for creating plots in NinjaScript Strategies
        /// </summary>
        /// <returns></returns>
        public Indicator.noftOrderFlowDeltaHistogram noftOrderFlowDeltaHistogram(Data.IDataSeries input, int lowerDeltaLimit, string lowerDeltaSound, bool markLimitBreak, int upperDeltaLimit, string upperDeltaSound)
        {
            return _indicator.noftOrderFlowDeltaHistogram(input, lowerDeltaLimit, lowerDeltaSound, markLimitBreak, upperDeltaLimit, upperDeltaSound);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftOrderFlowSequenceTracker noftOrderFlowSequenceTracker(int askIncreaseCount, int breakOutCotPosition, string calculation, bool currentBarRule, bool hHLLRule, int increaseCotPosition, int longBidDeclineCount, int longDeclineCotPosition, string longSound, bool previousBarRule, Color reverseFontColor, Color reverseLong, Color reverseShort, string shortSound, bool showMarker)
        {
            return _indicator.noftOrderFlowSequenceTracker(Input, askIncreaseCount, breakOutCotPosition, calculation, currentBarRule, hHLLRule, increaseCotPosition, longBidDeclineCount, longDeclineCotPosition, longSound, previousBarRule, reverseFontColor, reverseLong, reverseShort, shortSound, showMarker);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.noftOrderFlowSequenceTracker noftOrderFlowSequenceTracker(Data.IDataSeries input, int askIncreaseCount, int breakOutCotPosition, string calculation, bool currentBarRule, bool hHLLRule, int increaseCotPosition, int longBidDeclineCount, int longDeclineCotPosition, string longSound, bool previousBarRule, Color reverseFontColor, Color reverseLong, Color reverseShort, string shortSound, bool showMarker)
        {
            return _indicator.noftOrderFlowSequenceTracker(input, askIncreaseCount, breakOutCotPosition, calculation, currentBarRule, hHLLRule, increaseCotPosition, longBidDeclineCount, longDeclineCotPosition, longSound, previousBarRule, reverseFontColor, reverseLong, reverseShort, shortSound, showMarker);
        }

        /// <summary>
        /// Empty placeholder indicator for creating plots in NinjaScript Strategies
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftDeltaAverage noftDeltaAverage(Color deltaMaNegative, Color deltaMaPositive, int period)
        {
            return _indicator.noftDeltaAverage(Input, deltaMaNegative, deltaMaPositive, period);
        }

        /// <summary>
        /// Empty placeholder indicator for creating plots in NinjaScript Strategies
        /// </summary>
        /// <returns></returns>
        public Indicator.noftDeltaAverage noftDeltaAverage(Data.IDataSeries input, Color deltaMaNegative, Color deltaMaPositive, int period)
        {
            return _indicator.noftDeltaAverage(input, deltaMaNegative, deltaMaPositive, period);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Empty placeholder indicator for creating plots in NinjaScript Strategies
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftOrderFlowDeltaHistogram noftOrderFlowDeltaHistogram(int lowerDeltaLimit, string lowerDeltaSound, bool markLimitBreak, int upperDeltaLimit, string upperDeltaSound)
        {
            return _indicator.noftOrderFlowDeltaHistogram(Input, lowerDeltaLimit, lowerDeltaSound, markLimitBreak, upperDeltaLimit, upperDeltaSound);
        }

        /// <summary>
        /// Empty placeholder indicator for creating plots in NinjaScript Strategies
        /// </summary>
        /// <returns></returns>
        public Indicator.noftOrderFlowDeltaHistogram noftOrderFlowDeltaHistogram(Data.IDataSeries input, int lowerDeltaLimit, string lowerDeltaSound, bool markLimitBreak, int upperDeltaLimit, string upperDeltaSound)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.noftOrderFlowDeltaHistogram(input, lowerDeltaLimit, lowerDeltaSound, markLimitBreak, upperDeltaLimit, upperDeltaSound);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftOrderFlowSequenceTracker noftOrderFlowSequenceTracker(int askIncreaseCount, int breakOutCotPosition, string calculation, bool currentBarRule, bool hHLLRule, int increaseCotPosition, int longBidDeclineCount, int longDeclineCotPosition, string longSound, bool previousBarRule, Color reverseFontColor, Color reverseLong, Color reverseShort, string shortSound, bool showMarker)
        {
            return _indicator.noftOrderFlowSequenceTracker(Input, askIncreaseCount, breakOutCotPosition, calculation, currentBarRule, hHLLRule, increaseCotPosition, longBidDeclineCount, longDeclineCotPosition, longSound, previousBarRule, reverseFontColor, reverseLong, reverseShort, shortSound, showMarker);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.noftOrderFlowSequenceTracker noftOrderFlowSequenceTracker(Data.IDataSeries input, int askIncreaseCount, int breakOutCotPosition, string calculation, bool currentBarRule, bool hHLLRule, int increaseCotPosition, int longBidDeclineCount, int longDeclineCotPosition, string longSound, bool previousBarRule, Color reverseFontColor, Color reverseLong, Color reverseShort, string shortSound, bool showMarker)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.noftOrderFlowSequenceTracker(input, askIncreaseCount, breakOutCotPosition, calculation, currentBarRule, hHLLRule, increaseCotPosition, longBidDeclineCount, longDeclineCotPosition, longSound, previousBarRule, reverseFontColor, reverseLong, reverseShort, shortSound, showMarker);
        }

        /// <summary>
        /// Empty placeholder indicator for creating plots in NinjaScript Strategies
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftDeltaAverage noftDeltaAverage(Color deltaMaNegative, Color deltaMaPositive, int period)
        {
            return _indicator.noftDeltaAverage(Input, deltaMaNegative, deltaMaPositive, period);
        }

        /// <summary>
        /// Empty placeholder indicator for creating plots in NinjaScript Strategies
        /// </summary>
        /// <returns></returns>
        public Indicator.noftDeltaAverage noftDeltaAverage(Data.IDataSeries input, Color deltaMaNegative, Color deltaMaPositive, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.noftDeltaAverage(input, deltaMaNegative, deltaMaPositive, period);
        }
    }
}
#endregion
