//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private noftPriceMarker[] cachenoftPriceMarker = null;

        private static noftPriceMarker checknoftPriceMarker = new noftPriceMarker();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftPriceMarker noftPriceMarker(int length, Color lineColor, int width)
        {
            return noftPriceMarker(Input, length, lineColor, width);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftPriceMarker noftPriceMarker(Data.IDataSeries input, int length, Color lineColor, int width)
        {
            if (cachenoftPriceMarker != null)
                for (int idx = 0; idx < cachenoftPriceMarker.Length; idx++)
                    if (cachenoftPriceMarker[idx].Length == length && cachenoftPriceMarker[idx].LineColor == lineColor && cachenoftPriceMarker[idx].Width == width && cachenoftPriceMarker[idx].EqualsInput(input))
                        return cachenoftPriceMarker[idx];

            lock (checknoftPriceMarker)
            {
                checknoftPriceMarker.Length = length;
                length = checknoftPriceMarker.Length;
                checknoftPriceMarker.LineColor = lineColor;
                lineColor = checknoftPriceMarker.LineColor;
                checknoftPriceMarker.Width = width;
                width = checknoftPriceMarker.Width;

                if (cachenoftPriceMarker != null)
                    for (int idx = 0; idx < cachenoftPriceMarker.Length; idx++)
                        if (cachenoftPriceMarker[idx].Length == length && cachenoftPriceMarker[idx].LineColor == lineColor && cachenoftPriceMarker[idx].Width == width && cachenoftPriceMarker[idx].EqualsInput(input))
                            return cachenoftPriceMarker[idx];

                noftPriceMarker indicator = new noftPriceMarker();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Length = length;
                indicator.LineColor = lineColor;
                indicator.Width = width;
                Indicators.Add(indicator);
                indicator.SetUp();

                noftPriceMarker[] tmp = new noftPriceMarker[cachenoftPriceMarker == null ? 1 : cachenoftPriceMarker.Length + 1];
                if (cachenoftPriceMarker != null)
                    cachenoftPriceMarker.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachenoftPriceMarker = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftPriceMarker noftPriceMarker(int length, Color lineColor, int width)
        {
            return _indicator.noftPriceMarker(Input, length, lineColor, width);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftPriceMarker noftPriceMarker(Data.IDataSeries input, int length, Color lineColor, int width)
        {
            return _indicator.noftPriceMarker(input, length, lineColor, width);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftPriceMarker noftPriceMarker(int length, Color lineColor, int width)
        {
            return _indicator.noftPriceMarker(Input, length, lineColor, width);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftPriceMarker noftPriceMarker(Data.IDataSeries input, int length, Color lineColor, int width)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.noftPriceMarker(input, length, lineColor, width);
        }
    }
}
#endregion
