//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private noftSettlementDeviationLines[] cachenoftSettlementDeviationLines = null;

        private static noftSettlementDeviationLines checknoftSettlementDeviationLines = new noftSettlementDeviationLines();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftSettlementDeviationLines noftSettlementDeviationLines(int sessionEnd, bool showPlot, bool showSD1, bool showSD2, bool showSD3)
        {
            return noftSettlementDeviationLines(Input, sessionEnd, showPlot, showSD1, showSD2, showSD3);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftSettlementDeviationLines noftSettlementDeviationLines(Data.IDataSeries input, int sessionEnd, bool showPlot, bool showSD1, bool showSD2, bool showSD3)
        {
            if (cachenoftSettlementDeviationLines != null)
                for (int idx = 0; idx < cachenoftSettlementDeviationLines.Length; idx++)
                    if (cachenoftSettlementDeviationLines[idx].SessionEnd == sessionEnd && cachenoftSettlementDeviationLines[idx].ShowPlot == showPlot && cachenoftSettlementDeviationLines[idx].ShowSD1 == showSD1 && cachenoftSettlementDeviationLines[idx].ShowSD2 == showSD2 && cachenoftSettlementDeviationLines[idx].ShowSD3 == showSD3 && cachenoftSettlementDeviationLines[idx].EqualsInput(input))
                        return cachenoftSettlementDeviationLines[idx];

            lock (checknoftSettlementDeviationLines)
            {
                checknoftSettlementDeviationLines.SessionEnd = sessionEnd;
                sessionEnd = checknoftSettlementDeviationLines.SessionEnd;
                checknoftSettlementDeviationLines.ShowPlot = showPlot;
                showPlot = checknoftSettlementDeviationLines.ShowPlot;
                checknoftSettlementDeviationLines.ShowSD1 = showSD1;
                showSD1 = checknoftSettlementDeviationLines.ShowSD1;
                checknoftSettlementDeviationLines.ShowSD2 = showSD2;
                showSD2 = checknoftSettlementDeviationLines.ShowSD2;
                checknoftSettlementDeviationLines.ShowSD3 = showSD3;
                showSD3 = checknoftSettlementDeviationLines.ShowSD3;

                if (cachenoftSettlementDeviationLines != null)
                    for (int idx = 0; idx < cachenoftSettlementDeviationLines.Length; idx++)
                        if (cachenoftSettlementDeviationLines[idx].SessionEnd == sessionEnd && cachenoftSettlementDeviationLines[idx].ShowPlot == showPlot && cachenoftSettlementDeviationLines[idx].ShowSD1 == showSD1 && cachenoftSettlementDeviationLines[idx].ShowSD2 == showSD2 && cachenoftSettlementDeviationLines[idx].ShowSD3 == showSD3 && cachenoftSettlementDeviationLines[idx].EqualsInput(input))
                            return cachenoftSettlementDeviationLines[idx];

                noftSettlementDeviationLines indicator = new noftSettlementDeviationLines();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.SessionEnd = sessionEnd;
                indicator.ShowPlot = showPlot;
                indicator.ShowSD1 = showSD1;
                indicator.ShowSD2 = showSD2;
                indicator.ShowSD3 = showSD3;
                Indicators.Add(indicator);
                indicator.SetUp();

                noftSettlementDeviationLines[] tmp = new noftSettlementDeviationLines[cachenoftSettlementDeviationLines == null ? 1 : cachenoftSettlementDeviationLines.Length + 1];
                if (cachenoftSettlementDeviationLines != null)
                    cachenoftSettlementDeviationLines.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachenoftSettlementDeviationLines = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftSettlementDeviationLines noftSettlementDeviationLines(int sessionEnd, bool showPlot, bool showSD1, bool showSD2, bool showSD3)
        {
            return _indicator.noftSettlementDeviationLines(Input, sessionEnd, showPlot, showSD1, showSD2, showSD3);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftSettlementDeviationLines noftSettlementDeviationLines(Data.IDataSeries input, int sessionEnd, bool showPlot, bool showSD1, bool showSD2, bool showSD3)
        {
            return _indicator.noftSettlementDeviationLines(input, sessionEnd, showPlot, showSD1, showSD2, showSD3);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftSettlementDeviationLines noftSettlementDeviationLines(int sessionEnd, bool showPlot, bool showSD1, bool showSD2, bool showSD3)
        {
            return _indicator.noftSettlementDeviationLines(Input, sessionEnd, showPlot, showSD1, showSD2, showSD3);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftSettlementDeviationLines noftSettlementDeviationLines(Data.IDataSeries input, int sessionEnd, bool showPlot, bool showSD1, bool showSD2, bool showSD3)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.noftSettlementDeviationLines(input, sessionEnd, showPlot, showSD1, showSD2, showSD3);
        }
    }
}
#endregion
