//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private noftStaticVolumeProfile[] cachenoftStaticVolumeProfile = null;

        private static noftStaticVolumeProfile checknoftStaticVolumeProfile = new noftStaticVolumeProfile();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftStaticVolumeProfile noftStaticVolumeProfile(bool alertOnMarkersPrice, bool alertOnVAPcross, string alertSound, string calculationBarType, bool connectWithLines, bool drawMarkers, bool drawNaked, string drawSide, string drawStyle, bool extendMaxVapToEndZone, bool extendVaHighLine, bool extendVaLowLine, bool extendVPOCLines, bool heatColor, bool heatColorFill, Plot historicalVPOC, Plot maxVap, Plot nakedVPOC, int numberOfMarkers, int numberOfVA, string periodTypeVar, int periodValue, bool showCurrentDay, bool showVaHighLine, bool showVaLines, bool showVaLowLine, bool showValueArea, bool showZoneHorizontalLine, bool showZoneVerticalLine, Plot vAHigh, Plot vALow, Color valueAreaColor, int valueAreaColorAlpha, int valueAreaLevel, Color vapColor, int vapColorAlpha, Plot vAPOutline, int vapWidth, Plot zoneLines)
        {
            return noftStaticVolumeProfile(Input, alertOnMarkersPrice, alertOnVAPcross, alertSound, calculationBarType, connectWithLines, drawMarkers, drawNaked, drawSide, drawStyle, extendMaxVapToEndZone, extendVaHighLine, extendVaLowLine, extendVPOCLines, heatColor, heatColorFill, historicalVPOC, maxVap, nakedVPOC, numberOfMarkers, numberOfVA, periodTypeVar, periodValue, showCurrentDay, showVaHighLine, showVaLines, showVaLowLine, showValueArea, showZoneHorizontalLine, showZoneVerticalLine, vAHigh, vALow, valueAreaColor, valueAreaColorAlpha, valueAreaLevel, vapColor, vapColorAlpha, vAPOutline, vapWidth, zoneLines);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftStaticVolumeProfile noftStaticVolumeProfile(Data.IDataSeries input, bool alertOnMarkersPrice, bool alertOnVAPcross, string alertSound, string calculationBarType, bool connectWithLines, bool drawMarkers, bool drawNaked, string drawSide, string drawStyle, bool extendMaxVapToEndZone, bool extendVaHighLine, bool extendVaLowLine, bool extendVPOCLines, bool heatColor, bool heatColorFill, Plot historicalVPOC, Plot maxVap, Plot nakedVPOC, int numberOfMarkers, int numberOfVA, string periodTypeVar, int periodValue, bool showCurrentDay, bool showVaHighLine, bool showVaLines, bool showVaLowLine, bool showValueArea, bool showZoneHorizontalLine, bool showZoneVerticalLine, Plot vAHigh, Plot vALow, Color valueAreaColor, int valueAreaColorAlpha, int valueAreaLevel, Color vapColor, int vapColorAlpha, Plot vAPOutline, int vapWidth, Plot zoneLines)
        {
            if (cachenoftStaticVolumeProfile != null)
                for (int idx = 0; idx < cachenoftStaticVolumeProfile.Length; idx++)
                    if (cachenoftStaticVolumeProfile[idx].AlertOnMarkersPrice == alertOnMarkersPrice && cachenoftStaticVolumeProfile[idx].AlertOnVAPcross == alertOnVAPcross && cachenoftStaticVolumeProfile[idx].AlertSound == alertSound && cachenoftStaticVolumeProfile[idx].CalculationBarType == calculationBarType && cachenoftStaticVolumeProfile[idx].ConnectWithLines == connectWithLines && cachenoftStaticVolumeProfile[idx].DrawMarkers == drawMarkers && cachenoftStaticVolumeProfile[idx].DrawNaked == drawNaked && cachenoftStaticVolumeProfile[idx].DrawSide == drawSide && cachenoftStaticVolumeProfile[idx].DrawStyle == drawStyle && cachenoftStaticVolumeProfile[idx].ExtendMaxVapToEndZone == extendMaxVapToEndZone && cachenoftStaticVolumeProfile[idx].ExtendVaHighLine == extendVaHighLine && cachenoftStaticVolumeProfile[idx].ExtendVaLowLine == extendVaLowLine && cachenoftStaticVolumeProfile[idx].ExtendVPOCLines == extendVPOCLines && cachenoftStaticVolumeProfile[idx].HeatColor == heatColor && cachenoftStaticVolumeProfile[idx].HeatColorFill == heatColorFill && cachenoftStaticVolumeProfile[idx].HistoricalVPOC == historicalVPOC && cachenoftStaticVolumeProfile[idx].MaxVap == maxVap && cachenoftStaticVolumeProfile[idx].NakedVPOC == nakedVPOC && cachenoftStaticVolumeProfile[idx].NumberOfMarkers == numberOfMarkers && cachenoftStaticVolumeProfile[idx].NumberOfVA == numberOfVA && cachenoftStaticVolumeProfile[idx].PeriodTypeVar == periodTypeVar && cachenoftStaticVolumeProfile[idx].PeriodValue == periodValue && cachenoftStaticVolumeProfile[idx].ShowCurrentDay == showCurrentDay && cachenoftStaticVolumeProfile[idx].ShowVaHighLine == showVaHighLine && cachenoftStaticVolumeProfile[idx].ShowVaLines == showVaLines && cachenoftStaticVolumeProfile[idx].ShowVaLowLine == showVaLowLine && cachenoftStaticVolumeProfile[idx].ShowValueArea == showValueArea && cachenoftStaticVolumeProfile[idx].ShowZoneHorizontalLine == showZoneHorizontalLine && cachenoftStaticVolumeProfile[idx].ShowZoneVerticalLine == showZoneVerticalLine && cachenoftStaticVolumeProfile[idx].VAHigh == vAHigh && cachenoftStaticVolumeProfile[idx].VALow == vALow && cachenoftStaticVolumeProfile[idx].ValueAreaColor == valueAreaColor && cachenoftStaticVolumeProfile[idx].ValueAreaColorAlpha == valueAreaColorAlpha && cachenoftStaticVolumeProfile[idx].ValueAreaLevel == valueAreaLevel && cachenoftStaticVolumeProfile[idx].VapColor == vapColor && cachenoftStaticVolumeProfile[idx].VapColorAlpha == vapColorAlpha && cachenoftStaticVolumeProfile[idx].VAPOutline == vAPOutline && cachenoftStaticVolumeProfile[idx].VapWidth == vapWidth && cachenoftStaticVolumeProfile[idx].ZoneLines == zoneLines && cachenoftStaticVolumeProfile[idx].EqualsInput(input))
                        return cachenoftStaticVolumeProfile[idx];

            lock (checknoftStaticVolumeProfile)
            {
                checknoftStaticVolumeProfile.AlertOnMarkersPrice = alertOnMarkersPrice;
                alertOnMarkersPrice = checknoftStaticVolumeProfile.AlertOnMarkersPrice;
                checknoftStaticVolumeProfile.AlertOnVAPcross = alertOnVAPcross;
                alertOnVAPcross = checknoftStaticVolumeProfile.AlertOnVAPcross;
                checknoftStaticVolumeProfile.AlertSound = alertSound;
                alertSound = checknoftStaticVolumeProfile.AlertSound;
                checknoftStaticVolumeProfile.CalculationBarType = calculationBarType;
                calculationBarType = checknoftStaticVolumeProfile.CalculationBarType;
                checknoftStaticVolumeProfile.ConnectWithLines = connectWithLines;
                connectWithLines = checknoftStaticVolumeProfile.ConnectWithLines;
                checknoftStaticVolumeProfile.DrawMarkers = drawMarkers;
                drawMarkers = checknoftStaticVolumeProfile.DrawMarkers;
                checknoftStaticVolumeProfile.DrawNaked = drawNaked;
                drawNaked = checknoftStaticVolumeProfile.DrawNaked;
                checknoftStaticVolumeProfile.DrawSide = drawSide;
                drawSide = checknoftStaticVolumeProfile.DrawSide;
                checknoftStaticVolumeProfile.DrawStyle = drawStyle;
                drawStyle = checknoftStaticVolumeProfile.DrawStyle;
                checknoftStaticVolumeProfile.ExtendMaxVapToEndZone = extendMaxVapToEndZone;
                extendMaxVapToEndZone = checknoftStaticVolumeProfile.ExtendMaxVapToEndZone;
                checknoftStaticVolumeProfile.ExtendVaHighLine = extendVaHighLine;
                extendVaHighLine = checknoftStaticVolumeProfile.ExtendVaHighLine;
                checknoftStaticVolumeProfile.ExtendVaLowLine = extendVaLowLine;
                extendVaLowLine = checknoftStaticVolumeProfile.ExtendVaLowLine;
                checknoftStaticVolumeProfile.ExtendVPOCLines = extendVPOCLines;
                extendVPOCLines = checknoftStaticVolumeProfile.ExtendVPOCLines;
                checknoftStaticVolumeProfile.HeatColor = heatColor;
                heatColor = checknoftStaticVolumeProfile.HeatColor;
                checknoftStaticVolumeProfile.HeatColorFill = heatColorFill;
                heatColorFill = checknoftStaticVolumeProfile.HeatColorFill;
                checknoftStaticVolumeProfile.HistoricalVPOC = historicalVPOC;
                historicalVPOC = checknoftStaticVolumeProfile.HistoricalVPOC;
                checknoftStaticVolumeProfile.MaxVap = maxVap;
                maxVap = checknoftStaticVolumeProfile.MaxVap;
                checknoftStaticVolumeProfile.NakedVPOC = nakedVPOC;
                nakedVPOC = checknoftStaticVolumeProfile.NakedVPOC;
                checknoftStaticVolumeProfile.NumberOfMarkers = numberOfMarkers;
                numberOfMarkers = checknoftStaticVolumeProfile.NumberOfMarkers;
                checknoftStaticVolumeProfile.NumberOfVA = numberOfVA;
                numberOfVA = checknoftStaticVolumeProfile.NumberOfVA;
                checknoftStaticVolumeProfile.PeriodTypeVar = periodTypeVar;
                periodTypeVar = checknoftStaticVolumeProfile.PeriodTypeVar;
                checknoftStaticVolumeProfile.PeriodValue = periodValue;
                periodValue = checknoftStaticVolumeProfile.PeriodValue;
                checknoftStaticVolumeProfile.ShowCurrentDay = showCurrentDay;
                showCurrentDay = checknoftStaticVolumeProfile.ShowCurrentDay;
                checknoftStaticVolumeProfile.ShowVaHighLine = showVaHighLine;
                showVaHighLine = checknoftStaticVolumeProfile.ShowVaHighLine;
                checknoftStaticVolumeProfile.ShowVaLines = showVaLines;
                showVaLines = checknoftStaticVolumeProfile.ShowVaLines;
                checknoftStaticVolumeProfile.ShowVaLowLine = showVaLowLine;
                showVaLowLine = checknoftStaticVolumeProfile.ShowVaLowLine;
                checknoftStaticVolumeProfile.ShowValueArea = showValueArea;
                showValueArea = checknoftStaticVolumeProfile.ShowValueArea;
                checknoftStaticVolumeProfile.ShowZoneHorizontalLine = showZoneHorizontalLine;
                showZoneHorizontalLine = checknoftStaticVolumeProfile.ShowZoneHorizontalLine;
                checknoftStaticVolumeProfile.ShowZoneVerticalLine = showZoneVerticalLine;
                showZoneVerticalLine = checknoftStaticVolumeProfile.ShowZoneVerticalLine;
                checknoftStaticVolumeProfile.VAHigh = vAHigh;
                vAHigh = checknoftStaticVolumeProfile.VAHigh;
                checknoftStaticVolumeProfile.VALow = vALow;
                vALow = checknoftStaticVolumeProfile.VALow;
                checknoftStaticVolumeProfile.ValueAreaColor = valueAreaColor;
                valueAreaColor = checknoftStaticVolumeProfile.ValueAreaColor;
                checknoftStaticVolumeProfile.ValueAreaColorAlpha = valueAreaColorAlpha;
                valueAreaColorAlpha = checknoftStaticVolumeProfile.ValueAreaColorAlpha;
                checknoftStaticVolumeProfile.ValueAreaLevel = valueAreaLevel;
                valueAreaLevel = checknoftStaticVolumeProfile.ValueAreaLevel;
                checknoftStaticVolumeProfile.VapColor = vapColor;
                vapColor = checknoftStaticVolumeProfile.VapColor;
                checknoftStaticVolumeProfile.VapColorAlpha = vapColorAlpha;
                vapColorAlpha = checknoftStaticVolumeProfile.VapColorAlpha;
                checknoftStaticVolumeProfile.VAPOutline = vAPOutline;
                vAPOutline = checknoftStaticVolumeProfile.VAPOutline;
                checknoftStaticVolumeProfile.VapWidth = vapWidth;
                vapWidth = checknoftStaticVolumeProfile.VapWidth;
                checknoftStaticVolumeProfile.ZoneLines = zoneLines;
                zoneLines = checknoftStaticVolumeProfile.ZoneLines;

                if (cachenoftStaticVolumeProfile != null)
                    for (int idx = 0; idx < cachenoftStaticVolumeProfile.Length; idx++)
                        if (cachenoftStaticVolumeProfile[idx].AlertOnMarkersPrice == alertOnMarkersPrice && cachenoftStaticVolumeProfile[idx].AlertOnVAPcross == alertOnVAPcross && cachenoftStaticVolumeProfile[idx].AlertSound == alertSound && cachenoftStaticVolumeProfile[idx].CalculationBarType == calculationBarType && cachenoftStaticVolumeProfile[idx].ConnectWithLines == connectWithLines && cachenoftStaticVolumeProfile[idx].DrawMarkers == drawMarkers && cachenoftStaticVolumeProfile[idx].DrawNaked == drawNaked && cachenoftStaticVolumeProfile[idx].DrawSide == drawSide && cachenoftStaticVolumeProfile[idx].DrawStyle == drawStyle && cachenoftStaticVolumeProfile[idx].ExtendMaxVapToEndZone == extendMaxVapToEndZone && cachenoftStaticVolumeProfile[idx].ExtendVaHighLine == extendVaHighLine && cachenoftStaticVolumeProfile[idx].ExtendVaLowLine == extendVaLowLine && cachenoftStaticVolumeProfile[idx].ExtendVPOCLines == extendVPOCLines && cachenoftStaticVolumeProfile[idx].HeatColor == heatColor && cachenoftStaticVolumeProfile[idx].HeatColorFill == heatColorFill && cachenoftStaticVolumeProfile[idx].HistoricalVPOC == historicalVPOC && cachenoftStaticVolumeProfile[idx].MaxVap == maxVap && cachenoftStaticVolumeProfile[idx].NakedVPOC == nakedVPOC && cachenoftStaticVolumeProfile[idx].NumberOfMarkers == numberOfMarkers && cachenoftStaticVolumeProfile[idx].NumberOfVA == numberOfVA && cachenoftStaticVolumeProfile[idx].PeriodTypeVar == periodTypeVar && cachenoftStaticVolumeProfile[idx].PeriodValue == periodValue && cachenoftStaticVolumeProfile[idx].ShowCurrentDay == showCurrentDay && cachenoftStaticVolumeProfile[idx].ShowVaHighLine == showVaHighLine && cachenoftStaticVolumeProfile[idx].ShowVaLines == showVaLines && cachenoftStaticVolumeProfile[idx].ShowVaLowLine == showVaLowLine && cachenoftStaticVolumeProfile[idx].ShowValueArea == showValueArea && cachenoftStaticVolumeProfile[idx].ShowZoneHorizontalLine == showZoneHorizontalLine && cachenoftStaticVolumeProfile[idx].ShowZoneVerticalLine == showZoneVerticalLine && cachenoftStaticVolumeProfile[idx].VAHigh == vAHigh && cachenoftStaticVolumeProfile[idx].VALow == vALow && cachenoftStaticVolumeProfile[idx].ValueAreaColor == valueAreaColor && cachenoftStaticVolumeProfile[idx].ValueAreaColorAlpha == valueAreaColorAlpha && cachenoftStaticVolumeProfile[idx].ValueAreaLevel == valueAreaLevel && cachenoftStaticVolumeProfile[idx].VapColor == vapColor && cachenoftStaticVolumeProfile[idx].VapColorAlpha == vapColorAlpha && cachenoftStaticVolumeProfile[idx].VAPOutline == vAPOutline && cachenoftStaticVolumeProfile[idx].VapWidth == vapWidth && cachenoftStaticVolumeProfile[idx].ZoneLines == zoneLines && cachenoftStaticVolumeProfile[idx].EqualsInput(input))
                            return cachenoftStaticVolumeProfile[idx];

                noftStaticVolumeProfile indicator = new noftStaticVolumeProfile();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.AlertOnMarkersPrice = alertOnMarkersPrice;
                indicator.AlertOnVAPcross = alertOnVAPcross;
                indicator.AlertSound = alertSound;
                indicator.CalculationBarType = calculationBarType;
                indicator.ConnectWithLines = connectWithLines;
                indicator.DrawMarkers = drawMarkers;
                indicator.DrawNaked = drawNaked;
                indicator.DrawSide = drawSide;
                indicator.DrawStyle = drawStyle;
                indicator.ExtendMaxVapToEndZone = extendMaxVapToEndZone;
                indicator.ExtendVaHighLine = extendVaHighLine;
                indicator.ExtendVaLowLine = extendVaLowLine;
                indicator.ExtendVPOCLines = extendVPOCLines;
                indicator.HeatColor = heatColor;
                indicator.HeatColorFill = heatColorFill;
                indicator.HistoricalVPOC = historicalVPOC;
                indicator.MaxVap = maxVap;
                indicator.NakedVPOC = nakedVPOC;
                indicator.NumberOfMarkers = numberOfMarkers;
                indicator.NumberOfVA = numberOfVA;
                indicator.PeriodTypeVar = periodTypeVar;
                indicator.PeriodValue = periodValue;
                indicator.ShowCurrentDay = showCurrentDay;
                indicator.ShowVaHighLine = showVaHighLine;
                indicator.ShowVaLines = showVaLines;
                indicator.ShowVaLowLine = showVaLowLine;
                indicator.ShowValueArea = showValueArea;
                indicator.ShowZoneHorizontalLine = showZoneHorizontalLine;
                indicator.ShowZoneVerticalLine = showZoneVerticalLine;
                indicator.VAHigh = vAHigh;
                indicator.VALow = vALow;
                indicator.ValueAreaColor = valueAreaColor;
                indicator.ValueAreaColorAlpha = valueAreaColorAlpha;
                indicator.ValueAreaLevel = valueAreaLevel;
                indicator.VapColor = vapColor;
                indicator.VapColorAlpha = vapColorAlpha;
                indicator.VAPOutline = vAPOutline;
                indicator.VapWidth = vapWidth;
                indicator.ZoneLines = zoneLines;
                Indicators.Add(indicator);
                indicator.SetUp();

                noftStaticVolumeProfile[] tmp = new noftStaticVolumeProfile[cachenoftStaticVolumeProfile == null ? 1 : cachenoftStaticVolumeProfile.Length + 1];
                if (cachenoftStaticVolumeProfile != null)
                    cachenoftStaticVolumeProfile.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachenoftStaticVolumeProfile = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftStaticVolumeProfile noftStaticVolumeProfile(bool alertOnMarkersPrice, bool alertOnVAPcross, string alertSound, string calculationBarType, bool connectWithLines, bool drawMarkers, bool drawNaked, string drawSide, string drawStyle, bool extendMaxVapToEndZone, bool extendVaHighLine, bool extendVaLowLine, bool extendVPOCLines, bool heatColor, bool heatColorFill, Plot historicalVPOC, Plot maxVap, Plot nakedVPOC, int numberOfMarkers, int numberOfVA, string periodTypeVar, int periodValue, bool showCurrentDay, bool showVaHighLine, bool showVaLines, bool showVaLowLine, bool showValueArea, bool showZoneHorizontalLine, bool showZoneVerticalLine, Plot vAHigh, Plot vALow, Color valueAreaColor, int valueAreaColorAlpha, int valueAreaLevel, Color vapColor, int vapColorAlpha, Plot vAPOutline, int vapWidth, Plot zoneLines)
        {
            return _indicator.noftStaticVolumeProfile(Input, alertOnMarkersPrice, alertOnVAPcross, alertSound, calculationBarType, connectWithLines, drawMarkers, drawNaked, drawSide, drawStyle, extendMaxVapToEndZone, extendVaHighLine, extendVaLowLine, extendVPOCLines, heatColor, heatColorFill, historicalVPOC, maxVap, nakedVPOC, numberOfMarkers, numberOfVA, periodTypeVar, periodValue, showCurrentDay, showVaHighLine, showVaLines, showVaLowLine, showValueArea, showZoneHorizontalLine, showZoneVerticalLine, vAHigh, vALow, valueAreaColor, valueAreaColorAlpha, valueAreaLevel, vapColor, vapColorAlpha, vAPOutline, vapWidth, zoneLines);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftStaticVolumeProfile noftStaticVolumeProfile(Data.IDataSeries input, bool alertOnMarkersPrice, bool alertOnVAPcross, string alertSound, string calculationBarType, bool connectWithLines, bool drawMarkers, bool drawNaked, string drawSide, string drawStyle, bool extendMaxVapToEndZone, bool extendVaHighLine, bool extendVaLowLine, bool extendVPOCLines, bool heatColor, bool heatColorFill, Plot historicalVPOC, Plot maxVap, Plot nakedVPOC, int numberOfMarkers, int numberOfVA, string periodTypeVar, int periodValue, bool showCurrentDay, bool showVaHighLine, bool showVaLines, bool showVaLowLine, bool showValueArea, bool showZoneHorizontalLine, bool showZoneVerticalLine, Plot vAHigh, Plot vALow, Color valueAreaColor, int valueAreaColorAlpha, int valueAreaLevel, Color vapColor, int vapColorAlpha, Plot vAPOutline, int vapWidth, Plot zoneLines)
        {
            return _indicator.noftStaticVolumeProfile(input, alertOnMarkersPrice, alertOnVAPcross, alertSound, calculationBarType, connectWithLines, drawMarkers, drawNaked, drawSide, drawStyle, extendMaxVapToEndZone, extendVaHighLine, extendVaLowLine, extendVPOCLines, heatColor, heatColorFill, historicalVPOC, maxVap, nakedVPOC, numberOfMarkers, numberOfVA, periodTypeVar, periodValue, showCurrentDay, showVaHighLine, showVaLines, showVaLowLine, showValueArea, showZoneHorizontalLine, showZoneVerticalLine, vAHigh, vALow, valueAreaColor, valueAreaColorAlpha, valueAreaLevel, vapColor, vapColorAlpha, vAPOutline, vapWidth, zoneLines);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftStaticVolumeProfile noftStaticVolumeProfile(bool alertOnMarkersPrice, bool alertOnVAPcross, string alertSound, string calculationBarType, bool connectWithLines, bool drawMarkers, bool drawNaked, string drawSide, string drawStyle, bool extendMaxVapToEndZone, bool extendVaHighLine, bool extendVaLowLine, bool extendVPOCLines, bool heatColor, bool heatColorFill, Plot historicalVPOC, Plot maxVap, Plot nakedVPOC, int numberOfMarkers, int numberOfVA, string periodTypeVar, int periodValue, bool showCurrentDay, bool showVaHighLine, bool showVaLines, bool showVaLowLine, bool showValueArea, bool showZoneHorizontalLine, bool showZoneVerticalLine, Plot vAHigh, Plot vALow, Color valueAreaColor, int valueAreaColorAlpha, int valueAreaLevel, Color vapColor, int vapColorAlpha, Plot vAPOutline, int vapWidth, Plot zoneLines)
        {
            return _indicator.noftStaticVolumeProfile(Input, alertOnMarkersPrice, alertOnVAPcross, alertSound, calculationBarType, connectWithLines, drawMarkers, drawNaked, drawSide, drawStyle, extendMaxVapToEndZone, extendVaHighLine, extendVaLowLine, extendVPOCLines, heatColor, heatColorFill, historicalVPOC, maxVap, nakedVPOC, numberOfMarkers, numberOfVA, periodTypeVar, periodValue, showCurrentDay, showVaHighLine, showVaLines, showVaLowLine, showValueArea, showZoneHorizontalLine, showZoneVerticalLine, vAHigh, vALow, valueAreaColor, valueAreaColorAlpha, valueAreaLevel, vapColor, vapColorAlpha, vAPOutline, vapWidth, zoneLines);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftStaticVolumeProfile noftStaticVolumeProfile(Data.IDataSeries input, bool alertOnMarkersPrice, bool alertOnVAPcross, string alertSound, string calculationBarType, bool connectWithLines, bool drawMarkers, bool drawNaked, string drawSide, string drawStyle, bool extendMaxVapToEndZone, bool extendVaHighLine, bool extendVaLowLine, bool extendVPOCLines, bool heatColor, bool heatColorFill, Plot historicalVPOC, Plot maxVap, Plot nakedVPOC, int numberOfMarkers, int numberOfVA, string periodTypeVar, int periodValue, bool showCurrentDay, bool showVaHighLine, bool showVaLines, bool showVaLowLine, bool showValueArea, bool showZoneHorizontalLine, bool showZoneVerticalLine, Plot vAHigh, Plot vALow, Color valueAreaColor, int valueAreaColorAlpha, int valueAreaLevel, Color vapColor, int vapColorAlpha, Plot vAPOutline, int vapWidth, Plot zoneLines)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.noftStaticVolumeProfile(input, alertOnMarkersPrice, alertOnVAPcross, alertSound, calculationBarType, connectWithLines, drawMarkers, drawNaked, drawSide, drawStyle, extendMaxVapToEndZone, extendVaHighLine, extendVaLowLine, extendVPOCLines, heatColor, heatColorFill, historicalVPOC, maxVap, nakedVPOC, numberOfMarkers, numberOfVA, periodTypeVar, periodValue, showCurrentDay, showVaHighLine, showVaLines, showVaLowLine, showValueArea, showZoneHorizontalLine, showZoneVerticalLine, vAHigh, vALow, valueAreaColor, valueAreaColorAlpha, valueAreaLevel, vapColor, vapColorAlpha, vAPOutline, vapWidth, zoneLines);
        }
    }
}
#endregion
