//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private noftSupplyAndDemand[] cachenoftSupplyAndDemand = null;

        private static noftSupplyAndDemand checknoftSupplyAndDemand = new noftSupplyAndDemand();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftSupplyAndDemand noftSupplyAndDemand(string myPeriodType, int periodValue)
        {
            return noftSupplyAndDemand(Input, myPeriodType, periodValue);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftSupplyAndDemand noftSupplyAndDemand(Data.IDataSeries input, string myPeriodType, int periodValue)
        {
            if (cachenoftSupplyAndDemand != null)
                for (int idx = 0; idx < cachenoftSupplyAndDemand.Length; idx++)
                    if (cachenoftSupplyAndDemand[idx].MyPeriodType == myPeriodType && cachenoftSupplyAndDemand[idx].periodValue == periodValue && cachenoftSupplyAndDemand[idx].EqualsInput(input))
                        return cachenoftSupplyAndDemand[idx];

            lock (checknoftSupplyAndDemand)
            {
                checknoftSupplyAndDemand.MyPeriodType = myPeriodType;
                myPeriodType = checknoftSupplyAndDemand.MyPeriodType;
                checknoftSupplyAndDemand.periodValue = periodValue;
                periodValue = checknoftSupplyAndDemand.periodValue;

                if (cachenoftSupplyAndDemand != null)
                    for (int idx = 0; idx < cachenoftSupplyAndDemand.Length; idx++)
                        if (cachenoftSupplyAndDemand[idx].MyPeriodType == myPeriodType && cachenoftSupplyAndDemand[idx].periodValue == periodValue && cachenoftSupplyAndDemand[idx].EqualsInput(input))
                            return cachenoftSupplyAndDemand[idx];

                noftSupplyAndDemand indicator = new noftSupplyAndDemand();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.MyPeriodType = myPeriodType;
                indicator.periodValue = periodValue;
                Indicators.Add(indicator);
                indicator.SetUp();

                noftSupplyAndDemand[] tmp = new noftSupplyAndDemand[cachenoftSupplyAndDemand == null ? 1 : cachenoftSupplyAndDemand.Length + 1];
                if (cachenoftSupplyAndDemand != null)
                    cachenoftSupplyAndDemand.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachenoftSupplyAndDemand = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftSupplyAndDemand noftSupplyAndDemand(string myPeriodType, int periodValue)
        {
            return _indicator.noftSupplyAndDemand(Input, myPeriodType, periodValue);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftSupplyAndDemand noftSupplyAndDemand(Data.IDataSeries input, string myPeriodType, int periodValue)
        {
            return _indicator.noftSupplyAndDemand(input, myPeriodType, periodValue);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftSupplyAndDemand noftSupplyAndDemand(string myPeriodType, int periodValue)
        {
            return _indicator.noftSupplyAndDemand(Input, myPeriodType, periodValue);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftSupplyAndDemand noftSupplyAndDemand(Data.IDataSeries input, string myPeriodType, int periodValue)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.noftSupplyAndDemand(input, myPeriodType, periodValue);
        }
    }
}
#endregion
