//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private noftTradingRange[] cachenoftTradingRange = null;

        private static noftTradingRange checknoftTradingRange = new noftTradingRange();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftTradingRange noftTradingRange(int numberOfBars)
        {
            return noftTradingRange(Input, numberOfBars);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftTradingRange noftTradingRange(Data.IDataSeries input, int numberOfBars)
        {
            if (cachenoftTradingRange != null)
                for (int idx = 0; idx < cachenoftTradingRange.Length; idx++)
                    if (cachenoftTradingRange[idx].NumberOfBars == numberOfBars && cachenoftTradingRange[idx].EqualsInput(input))
                        return cachenoftTradingRange[idx];

            lock (checknoftTradingRange)
            {
                checknoftTradingRange.NumberOfBars = numberOfBars;
                numberOfBars = checknoftTradingRange.NumberOfBars;

                if (cachenoftTradingRange != null)
                    for (int idx = 0; idx < cachenoftTradingRange.Length; idx++)
                        if (cachenoftTradingRange[idx].NumberOfBars == numberOfBars && cachenoftTradingRange[idx].EqualsInput(input))
                            return cachenoftTradingRange[idx];

                noftTradingRange indicator = new noftTradingRange();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.NumberOfBars = numberOfBars;
                Indicators.Add(indicator);
                indicator.SetUp();

                noftTradingRange[] tmp = new noftTradingRange[cachenoftTradingRange == null ? 1 : cachenoftTradingRange.Length + 1];
                if (cachenoftTradingRange != null)
                    cachenoftTradingRange.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachenoftTradingRange = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftTradingRange noftTradingRange(int numberOfBars)
        {
            return _indicator.noftTradingRange(Input, numberOfBars);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftTradingRange noftTradingRange(Data.IDataSeries input, int numberOfBars)
        {
            return _indicator.noftTradingRange(input, numberOfBars);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftTradingRange noftTradingRange(int numberOfBars)
        {
            return _indicator.noftTradingRange(Input, numberOfBars);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftTradingRange noftTradingRange(Data.IDataSeries input, int numberOfBars)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.noftTradingRange(input, numberOfBars);
        }
    }
}
#endregion
