//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private noftVWAP[] cachenoftVWAP = null;

        private static noftVWAP checknoftVWAP = new noftVWAP();

        /// <summary>
        /// noftVWAP is the ratio of the value traded to total volume traded over a particular time horizon (usually one day). It is a measure of the average price a stock traded at over the trading horizon.
        /// </summary>
        /// <returns></returns>
        public noftVWAP noftVWAP()
        {
            return noftVWAP(Input);
        }

        /// <summary>
        /// noftVWAP is the ratio of the value traded to total volume traded over a particular time horizon (usually one day). It is a measure of the average price a stock traded at over the trading horizon.
        /// </summary>
        /// <returns></returns>
        public noftVWAP noftVWAP(Data.IDataSeries input)
        {
            if (cachenoftVWAP != null)
                for (int idx = 0; idx < cachenoftVWAP.Length; idx++)
                    if (cachenoftVWAP[idx].EqualsInput(input))
                        return cachenoftVWAP[idx];

            lock (checknoftVWAP)
            {
                if (cachenoftVWAP != null)
                    for (int idx = 0; idx < cachenoftVWAP.Length; idx++)
                        if (cachenoftVWAP[idx].EqualsInput(input))
                            return cachenoftVWAP[idx];

                noftVWAP indicator = new noftVWAP();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                noftVWAP[] tmp = new noftVWAP[cachenoftVWAP == null ? 1 : cachenoftVWAP.Length + 1];
                if (cachenoftVWAP != null)
                    cachenoftVWAP.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachenoftVWAP = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// noftVWAP is the ratio of the value traded to total volume traded over a particular time horizon (usually one day). It is a measure of the average price a stock traded at over the trading horizon.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftVWAP noftVWAP()
        {
            return _indicator.noftVWAP(Input);
        }

        /// <summary>
        /// noftVWAP is the ratio of the value traded to total volume traded over a particular time horizon (usually one day). It is a measure of the average price a stock traded at over the trading horizon.
        /// </summary>
        /// <returns></returns>
        public Indicator.noftVWAP noftVWAP(Data.IDataSeries input)
        {
            return _indicator.noftVWAP(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// noftVWAP is the ratio of the value traded to total volume traded over a particular time horizon (usually one day). It is a measure of the average price a stock traded at over the trading horizon.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftVWAP noftVWAP()
        {
            return _indicator.noftVWAP(Input);
        }

        /// <summary>
        /// noftVWAP is the ratio of the value traded to total volume traded over a particular time horizon (usually one day). It is a measure of the average price a stock traded at over the trading horizon.
        /// </summary>
        /// <returns></returns>
        public Indicator.noftVWAP noftVWAP(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.noftVWAP(input);
        }
    }
}
#endregion
