//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private noftValueArea[] cachenoftValueArea = null;

        private static noftValueArea checknoftValueArea = new noftValueArea();

        /// <summary>
        /// The Value Area is the price range where 70% of yesterdays volume traded
        /// </summary>
        /// <returns></returns>
        public noftValueArea noftValueArea(int closeHour, int closeMinute, bool extendVAlines, int historicalVAlines, int openHour, int openMinute, double pctOfVolumeInVA, string profileType, bool showPlot)
        {
            return noftValueArea(Input, closeHour, closeMinute, extendVAlines, historicalVAlines, openHour, openMinute, pctOfVolumeInVA, profileType, showPlot);
        }

        /// <summary>
        /// The Value Area is the price range where 70% of yesterdays volume traded
        /// </summary>
        /// <returns></returns>
        public noftValueArea noftValueArea(Data.IDataSeries input, int closeHour, int closeMinute, bool extendVAlines, int historicalVAlines, int openHour, int openMinute, double pctOfVolumeInVA, string profileType, bool showPlot)
        {
            if (cachenoftValueArea != null)
                for (int idx = 0; idx < cachenoftValueArea.Length; idx++)
                    if (cachenoftValueArea[idx].CloseHour == closeHour && cachenoftValueArea[idx].CloseMinute == closeMinute && cachenoftValueArea[idx].ExtendVAlines == extendVAlines && cachenoftValueArea[idx].HistoricalVAlines == historicalVAlines && cachenoftValueArea[idx].OpenHour == openHour && cachenoftValueArea[idx].OpenMinute == openMinute && Math.Abs(cachenoftValueArea[idx].PctOfVolumeInVA - pctOfVolumeInVA) <= double.Epsilon && cachenoftValueArea[idx].ProfileType == profileType && cachenoftValueArea[idx].ShowPlot == showPlot && cachenoftValueArea[idx].EqualsInput(input))
                        return cachenoftValueArea[idx];

            lock (checknoftValueArea)
            {
                checknoftValueArea.CloseHour = closeHour;
                closeHour = checknoftValueArea.CloseHour;
                checknoftValueArea.CloseMinute = closeMinute;
                closeMinute = checknoftValueArea.CloseMinute;
                checknoftValueArea.ExtendVAlines = extendVAlines;
                extendVAlines = checknoftValueArea.ExtendVAlines;
                checknoftValueArea.HistoricalVAlines = historicalVAlines;
                historicalVAlines = checknoftValueArea.HistoricalVAlines;
                checknoftValueArea.OpenHour = openHour;
                openHour = checknoftValueArea.OpenHour;
                checknoftValueArea.OpenMinute = openMinute;
                openMinute = checknoftValueArea.OpenMinute;
                checknoftValueArea.PctOfVolumeInVA = pctOfVolumeInVA;
                pctOfVolumeInVA = checknoftValueArea.PctOfVolumeInVA;
                checknoftValueArea.ProfileType = profileType;
                profileType = checknoftValueArea.ProfileType;
                checknoftValueArea.ShowPlot = showPlot;
                showPlot = checknoftValueArea.ShowPlot;

                if (cachenoftValueArea != null)
                    for (int idx = 0; idx < cachenoftValueArea.Length; idx++)
                        if (cachenoftValueArea[idx].CloseHour == closeHour && cachenoftValueArea[idx].CloseMinute == closeMinute && cachenoftValueArea[idx].ExtendVAlines == extendVAlines && cachenoftValueArea[idx].HistoricalVAlines == historicalVAlines && cachenoftValueArea[idx].OpenHour == openHour && cachenoftValueArea[idx].OpenMinute == openMinute && Math.Abs(cachenoftValueArea[idx].PctOfVolumeInVA - pctOfVolumeInVA) <= double.Epsilon && cachenoftValueArea[idx].ProfileType == profileType && cachenoftValueArea[idx].ShowPlot == showPlot && cachenoftValueArea[idx].EqualsInput(input))
                            return cachenoftValueArea[idx];

                noftValueArea indicator = new noftValueArea();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.CloseHour = closeHour;
                indicator.CloseMinute = closeMinute;
                indicator.ExtendVAlines = extendVAlines;
                indicator.HistoricalVAlines = historicalVAlines;
                indicator.OpenHour = openHour;
                indicator.OpenMinute = openMinute;
                indicator.PctOfVolumeInVA = pctOfVolumeInVA;
                indicator.ProfileType = profileType;
                indicator.ShowPlot = showPlot;
                Indicators.Add(indicator);
                indicator.SetUp();

                noftValueArea[] tmp = new noftValueArea[cachenoftValueArea == null ? 1 : cachenoftValueArea.Length + 1];
                if (cachenoftValueArea != null)
                    cachenoftValueArea.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachenoftValueArea = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// The Value Area is the price range where 70% of yesterdays volume traded
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftValueArea noftValueArea(int closeHour, int closeMinute, bool extendVAlines, int historicalVAlines, int openHour, int openMinute, double pctOfVolumeInVA, string profileType, bool showPlot)
        {
            return _indicator.noftValueArea(Input, closeHour, closeMinute, extendVAlines, historicalVAlines, openHour, openMinute, pctOfVolumeInVA, profileType, showPlot);
        }

        /// <summary>
        /// The Value Area is the price range where 70% of yesterdays volume traded
        /// </summary>
        /// <returns></returns>
        public Indicator.noftValueArea noftValueArea(Data.IDataSeries input, int closeHour, int closeMinute, bool extendVAlines, int historicalVAlines, int openHour, int openMinute, double pctOfVolumeInVA, string profileType, bool showPlot)
        {
            return _indicator.noftValueArea(input, closeHour, closeMinute, extendVAlines, historicalVAlines, openHour, openMinute, pctOfVolumeInVA, profileType, showPlot);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// The Value Area is the price range where 70% of yesterdays volume traded
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftValueArea noftValueArea(int closeHour, int closeMinute, bool extendVAlines, int historicalVAlines, int openHour, int openMinute, double pctOfVolumeInVA, string profileType, bool showPlot)
        {
            return _indicator.noftValueArea(Input, closeHour, closeMinute, extendVAlines, historicalVAlines, openHour, openMinute, pctOfVolumeInVA, profileType, showPlot);
        }

        /// <summary>
        /// The Value Area is the price range where 70% of yesterdays volume traded
        /// </summary>
        /// <returns></returns>
        public Indicator.noftValueArea noftValueArea(Data.IDataSeries input, int closeHour, int closeMinute, bool extendVAlines, int historicalVAlines, int openHour, int openMinute, double pctOfVolumeInVA, string profileType, bool showPlot)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.noftValueArea(input, closeHour, closeMinute, extendVAlines, historicalVAlines, openHour, openMinute, pctOfVolumeInVA, profileType, showPlot);
        }
    }
}
#endregion
