//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private noftVolumeAtPrice[] cachenoftVolumeAtPrice = null;

        private static noftVolumeAtPrice checknoftVolumeAtPrice = new noftVolumeAtPrice();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftVolumeAtPrice noftVolumeAtPrice(string drawStyle, int recordFrom, int recordTo, bool showMaxLine, bool showMaxVolume, bool showVaHighLine, bool showVaLowLine, bool showValueArea, string sound, Color valueAreaColor, int valueAreaColorAlpha, int valueAreaLevel, Color vapColor, int vapColorAlpha, int vAPwidth)
        {
            return noftVolumeAtPrice(Input, drawStyle, recordFrom, recordTo, showMaxLine, showMaxVolume, showVaHighLine, showVaLowLine, showValueArea, sound, valueAreaColor, valueAreaColorAlpha, valueAreaLevel, vapColor, vapColorAlpha, vAPwidth);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftVolumeAtPrice noftVolumeAtPrice(Data.IDataSeries input, string drawStyle, int recordFrom, int recordTo, bool showMaxLine, bool showMaxVolume, bool showVaHighLine, bool showVaLowLine, bool showValueArea, string sound, Color valueAreaColor, int valueAreaColorAlpha, int valueAreaLevel, Color vapColor, int vapColorAlpha, int vAPwidth)
        {
            if (cachenoftVolumeAtPrice != null)
                for (int idx = 0; idx < cachenoftVolumeAtPrice.Length; idx++)
                    if (cachenoftVolumeAtPrice[idx].DrawStyle == drawStyle && cachenoftVolumeAtPrice[idx].RecordFrom == recordFrom && cachenoftVolumeAtPrice[idx].RecordTo == recordTo && cachenoftVolumeAtPrice[idx].ShowMaxLine == showMaxLine && cachenoftVolumeAtPrice[idx].ShowMaxVolume == showMaxVolume && cachenoftVolumeAtPrice[idx].ShowVaHighLine == showVaHighLine && cachenoftVolumeAtPrice[idx].ShowVaLowLine == showVaLowLine && cachenoftVolumeAtPrice[idx].ShowValueArea == showValueArea && cachenoftVolumeAtPrice[idx].Sound == sound && cachenoftVolumeAtPrice[idx].ValueAreaColor == valueAreaColor && cachenoftVolumeAtPrice[idx].ValueAreaColorAlpha == valueAreaColorAlpha && cachenoftVolumeAtPrice[idx].ValueAreaLevel == valueAreaLevel && cachenoftVolumeAtPrice[idx].VapColor == vapColor && cachenoftVolumeAtPrice[idx].VapColorAlpha == vapColorAlpha && cachenoftVolumeAtPrice[idx].VAPwidth == vAPwidth && cachenoftVolumeAtPrice[idx].EqualsInput(input))
                        return cachenoftVolumeAtPrice[idx];

            lock (checknoftVolumeAtPrice)
            {
                checknoftVolumeAtPrice.DrawStyle = drawStyle;
                drawStyle = checknoftVolumeAtPrice.DrawStyle;
                checknoftVolumeAtPrice.RecordFrom = recordFrom;
                recordFrom = checknoftVolumeAtPrice.RecordFrom;
                checknoftVolumeAtPrice.RecordTo = recordTo;
                recordTo = checknoftVolumeAtPrice.RecordTo;
                checknoftVolumeAtPrice.ShowMaxLine = showMaxLine;
                showMaxLine = checknoftVolumeAtPrice.ShowMaxLine;
                checknoftVolumeAtPrice.ShowMaxVolume = showMaxVolume;
                showMaxVolume = checknoftVolumeAtPrice.ShowMaxVolume;
                checknoftVolumeAtPrice.ShowVaHighLine = showVaHighLine;
                showVaHighLine = checknoftVolumeAtPrice.ShowVaHighLine;
                checknoftVolumeAtPrice.ShowVaLowLine = showVaLowLine;
                showVaLowLine = checknoftVolumeAtPrice.ShowVaLowLine;
                checknoftVolumeAtPrice.ShowValueArea = showValueArea;
                showValueArea = checknoftVolumeAtPrice.ShowValueArea;
                checknoftVolumeAtPrice.Sound = sound;
                sound = checknoftVolumeAtPrice.Sound;
                checknoftVolumeAtPrice.ValueAreaColor = valueAreaColor;
                valueAreaColor = checknoftVolumeAtPrice.ValueAreaColor;
                checknoftVolumeAtPrice.ValueAreaColorAlpha = valueAreaColorAlpha;
                valueAreaColorAlpha = checknoftVolumeAtPrice.ValueAreaColorAlpha;
                checknoftVolumeAtPrice.ValueAreaLevel = valueAreaLevel;
                valueAreaLevel = checknoftVolumeAtPrice.ValueAreaLevel;
                checknoftVolumeAtPrice.VapColor = vapColor;
                vapColor = checknoftVolumeAtPrice.VapColor;
                checknoftVolumeAtPrice.VapColorAlpha = vapColorAlpha;
                vapColorAlpha = checknoftVolumeAtPrice.VapColorAlpha;
                checknoftVolumeAtPrice.VAPwidth = vAPwidth;
                vAPwidth = checknoftVolumeAtPrice.VAPwidth;

                if (cachenoftVolumeAtPrice != null)
                    for (int idx = 0; idx < cachenoftVolumeAtPrice.Length; idx++)
                        if (cachenoftVolumeAtPrice[idx].DrawStyle == drawStyle && cachenoftVolumeAtPrice[idx].RecordFrom == recordFrom && cachenoftVolumeAtPrice[idx].RecordTo == recordTo && cachenoftVolumeAtPrice[idx].ShowMaxLine == showMaxLine && cachenoftVolumeAtPrice[idx].ShowMaxVolume == showMaxVolume && cachenoftVolumeAtPrice[idx].ShowVaHighLine == showVaHighLine && cachenoftVolumeAtPrice[idx].ShowVaLowLine == showVaLowLine && cachenoftVolumeAtPrice[idx].ShowValueArea == showValueArea && cachenoftVolumeAtPrice[idx].Sound == sound && cachenoftVolumeAtPrice[idx].ValueAreaColor == valueAreaColor && cachenoftVolumeAtPrice[idx].ValueAreaColorAlpha == valueAreaColorAlpha && cachenoftVolumeAtPrice[idx].ValueAreaLevel == valueAreaLevel && cachenoftVolumeAtPrice[idx].VapColor == vapColor && cachenoftVolumeAtPrice[idx].VapColorAlpha == vapColorAlpha && cachenoftVolumeAtPrice[idx].VAPwidth == vAPwidth && cachenoftVolumeAtPrice[idx].EqualsInput(input))
                            return cachenoftVolumeAtPrice[idx];

                noftVolumeAtPrice indicator = new noftVolumeAtPrice();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.DrawStyle = drawStyle;
                indicator.RecordFrom = recordFrom;
                indicator.RecordTo = recordTo;
                indicator.ShowMaxLine = showMaxLine;
                indicator.ShowMaxVolume = showMaxVolume;
                indicator.ShowVaHighLine = showVaHighLine;
                indicator.ShowVaLowLine = showVaLowLine;
                indicator.ShowValueArea = showValueArea;
                indicator.Sound = sound;
                indicator.ValueAreaColor = valueAreaColor;
                indicator.ValueAreaColorAlpha = valueAreaColorAlpha;
                indicator.ValueAreaLevel = valueAreaLevel;
                indicator.VapColor = vapColor;
                indicator.VapColorAlpha = vapColorAlpha;
                indicator.VAPwidth = vAPwidth;
                Indicators.Add(indicator);
                indicator.SetUp();

                noftVolumeAtPrice[] tmp = new noftVolumeAtPrice[cachenoftVolumeAtPrice == null ? 1 : cachenoftVolumeAtPrice.Length + 1];
                if (cachenoftVolumeAtPrice != null)
                    cachenoftVolumeAtPrice.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachenoftVolumeAtPrice = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftVolumeAtPrice noftVolumeAtPrice(string drawStyle, int recordFrom, int recordTo, bool showMaxLine, bool showMaxVolume, bool showVaHighLine, bool showVaLowLine, bool showValueArea, string sound, Color valueAreaColor, int valueAreaColorAlpha, int valueAreaLevel, Color vapColor, int vapColorAlpha, int vAPwidth)
        {
            return _indicator.noftVolumeAtPrice(Input, drawStyle, recordFrom, recordTo, showMaxLine, showMaxVolume, showVaHighLine, showVaLowLine, showValueArea, sound, valueAreaColor, valueAreaColorAlpha, valueAreaLevel, vapColor, vapColorAlpha, vAPwidth);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftVolumeAtPrice noftVolumeAtPrice(Data.IDataSeries input, string drawStyle, int recordFrom, int recordTo, bool showMaxLine, bool showMaxVolume, bool showVaHighLine, bool showVaLowLine, bool showValueArea, string sound, Color valueAreaColor, int valueAreaColorAlpha, int valueAreaLevel, Color vapColor, int vapColorAlpha, int vAPwidth)
        {
            return _indicator.noftVolumeAtPrice(input, drawStyle, recordFrom, recordTo, showMaxLine, showMaxVolume, showVaHighLine, showVaLowLine, showValueArea, sound, valueAreaColor, valueAreaColorAlpha, valueAreaLevel, vapColor, vapColorAlpha, vAPwidth);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftVolumeAtPrice noftVolumeAtPrice(string drawStyle, int recordFrom, int recordTo, bool showMaxLine, bool showMaxVolume, bool showVaHighLine, bool showVaLowLine, bool showValueArea, string sound, Color valueAreaColor, int valueAreaColorAlpha, int valueAreaLevel, Color vapColor, int vapColorAlpha, int vAPwidth)
        {
            return _indicator.noftVolumeAtPrice(Input, drawStyle, recordFrom, recordTo, showMaxLine, showMaxVolume, showVaHighLine, showVaLowLine, showValueArea, sound, valueAreaColor, valueAreaColorAlpha, valueAreaLevel, vapColor, vapColorAlpha, vAPwidth);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftVolumeAtPrice noftVolumeAtPrice(Data.IDataSeries input, string drawStyle, int recordFrom, int recordTo, bool showMaxLine, bool showMaxVolume, bool showVaHighLine, bool showVaLowLine, bool showValueArea, string sound, Color valueAreaColor, int valueAreaColorAlpha, int valueAreaLevel, Color vapColor, int vapColorAlpha, int vAPwidth)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.noftVolumeAtPrice(input, drawStyle, recordFrom, recordTo, showMaxLine, showMaxVolume, showVaHighLine, showVaLowLine, showValueArea, sound, valueAreaColor, valueAreaColorAlpha, valueAreaLevel, vapColor, vapColorAlpha, vAPwidth);
        }
    }
}
#endregion
