//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private noftVolumeComposite[] cachenoftVolumeComposite = null;

        private static noftVolumeComposite checknoftVolumeComposite = new noftVolumeComposite();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftVolumeComposite noftVolumeComposite(string calculationBarType, string drawStyle, bool heatColor, string movingPeriodType, int movingPeriodValue, int showLowVolume, bool showMaxLine, bool showMaxVolume, bool showVaHighLine, bool showVaLowLine, bool showValueArea, bool signalAlert, string sound, Color valueAreaColor, int valueAreaColorAlpha, int valueAreaLevel, Color vapColor, int vapColorAlpha, int vAPwidth)
        {
            return noftVolumeComposite(Input, calculationBarType, drawStyle, heatColor, movingPeriodType, movingPeriodValue, showLowVolume, showMaxLine, showMaxVolume, showVaHighLine, showVaLowLine, showValueArea, signalAlert, sound, valueAreaColor, valueAreaColorAlpha, valueAreaLevel, vapColor, vapColorAlpha, vAPwidth);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public noftVolumeComposite noftVolumeComposite(Data.IDataSeries input, string calculationBarType, string drawStyle, bool heatColor, string movingPeriodType, int movingPeriodValue, int showLowVolume, bool showMaxLine, bool showMaxVolume, bool showVaHighLine, bool showVaLowLine, bool showValueArea, bool signalAlert, string sound, Color valueAreaColor, int valueAreaColorAlpha, int valueAreaLevel, Color vapColor, int vapColorAlpha, int vAPwidth)
        {
            if (cachenoftVolumeComposite != null)
                for (int idx = 0; idx < cachenoftVolumeComposite.Length; idx++)
                    if (cachenoftVolumeComposite[idx].CalculationBarType == calculationBarType && cachenoftVolumeComposite[idx].DrawStyle == drawStyle && cachenoftVolumeComposite[idx].HeatColor == heatColor && cachenoftVolumeComposite[idx].MovingPeriodType == movingPeriodType && cachenoftVolumeComposite[idx].MovingPeriodValue == movingPeriodValue && cachenoftVolumeComposite[idx].ShowLowVolume == showLowVolume && cachenoftVolumeComposite[idx].ShowMaxLine == showMaxLine && cachenoftVolumeComposite[idx].ShowMaxVolume == showMaxVolume && cachenoftVolumeComposite[idx].ShowVaHighLine == showVaHighLine && cachenoftVolumeComposite[idx].ShowVaLowLine == showVaLowLine && cachenoftVolumeComposite[idx].ShowValueArea == showValueArea && cachenoftVolumeComposite[idx].SignalAlert == signalAlert && cachenoftVolumeComposite[idx].Sound == sound && cachenoftVolumeComposite[idx].ValueAreaColor == valueAreaColor && cachenoftVolumeComposite[idx].ValueAreaColorAlpha == valueAreaColorAlpha && cachenoftVolumeComposite[idx].ValueAreaLevel == valueAreaLevel && cachenoftVolumeComposite[idx].VapColor == vapColor && cachenoftVolumeComposite[idx].VapColorAlpha == vapColorAlpha && cachenoftVolumeComposite[idx].VAPwidth == vAPwidth && cachenoftVolumeComposite[idx].EqualsInput(input))
                        return cachenoftVolumeComposite[idx];

            lock (checknoftVolumeComposite)
            {
                checknoftVolumeComposite.CalculationBarType = calculationBarType;
                calculationBarType = checknoftVolumeComposite.CalculationBarType;
                checknoftVolumeComposite.DrawStyle = drawStyle;
                drawStyle = checknoftVolumeComposite.DrawStyle;
                checknoftVolumeComposite.HeatColor = heatColor;
                heatColor = checknoftVolumeComposite.HeatColor;
                checknoftVolumeComposite.MovingPeriodType = movingPeriodType;
                movingPeriodType = checknoftVolumeComposite.MovingPeriodType;
                checknoftVolumeComposite.MovingPeriodValue = movingPeriodValue;
                movingPeriodValue = checknoftVolumeComposite.MovingPeriodValue;
                checknoftVolumeComposite.ShowLowVolume = showLowVolume;
                showLowVolume = checknoftVolumeComposite.ShowLowVolume;
                checknoftVolumeComposite.ShowMaxLine = showMaxLine;
                showMaxLine = checknoftVolumeComposite.ShowMaxLine;
                checknoftVolumeComposite.ShowMaxVolume = showMaxVolume;
                showMaxVolume = checknoftVolumeComposite.ShowMaxVolume;
                checknoftVolumeComposite.ShowVaHighLine = showVaHighLine;
                showVaHighLine = checknoftVolumeComposite.ShowVaHighLine;
                checknoftVolumeComposite.ShowVaLowLine = showVaLowLine;
                showVaLowLine = checknoftVolumeComposite.ShowVaLowLine;
                checknoftVolumeComposite.ShowValueArea = showValueArea;
                showValueArea = checknoftVolumeComposite.ShowValueArea;
                checknoftVolumeComposite.SignalAlert = signalAlert;
                signalAlert = checknoftVolumeComposite.SignalAlert;
                checknoftVolumeComposite.Sound = sound;
                sound = checknoftVolumeComposite.Sound;
                checknoftVolumeComposite.ValueAreaColor = valueAreaColor;
                valueAreaColor = checknoftVolumeComposite.ValueAreaColor;
                checknoftVolumeComposite.ValueAreaColorAlpha = valueAreaColorAlpha;
                valueAreaColorAlpha = checknoftVolumeComposite.ValueAreaColorAlpha;
                checknoftVolumeComposite.ValueAreaLevel = valueAreaLevel;
                valueAreaLevel = checknoftVolumeComposite.ValueAreaLevel;
                checknoftVolumeComposite.VapColor = vapColor;
                vapColor = checknoftVolumeComposite.VapColor;
                checknoftVolumeComposite.VapColorAlpha = vapColorAlpha;
                vapColorAlpha = checknoftVolumeComposite.VapColorAlpha;
                checknoftVolumeComposite.VAPwidth = vAPwidth;
                vAPwidth = checknoftVolumeComposite.VAPwidth;

                if (cachenoftVolumeComposite != null)
                    for (int idx = 0; idx < cachenoftVolumeComposite.Length; idx++)
                        if (cachenoftVolumeComposite[idx].CalculationBarType == calculationBarType && cachenoftVolumeComposite[idx].DrawStyle == drawStyle && cachenoftVolumeComposite[idx].HeatColor == heatColor && cachenoftVolumeComposite[idx].MovingPeriodType == movingPeriodType && cachenoftVolumeComposite[idx].MovingPeriodValue == movingPeriodValue && cachenoftVolumeComposite[idx].ShowLowVolume == showLowVolume && cachenoftVolumeComposite[idx].ShowMaxLine == showMaxLine && cachenoftVolumeComposite[idx].ShowMaxVolume == showMaxVolume && cachenoftVolumeComposite[idx].ShowVaHighLine == showVaHighLine && cachenoftVolumeComposite[idx].ShowVaLowLine == showVaLowLine && cachenoftVolumeComposite[idx].ShowValueArea == showValueArea && cachenoftVolumeComposite[idx].SignalAlert == signalAlert && cachenoftVolumeComposite[idx].Sound == sound && cachenoftVolumeComposite[idx].ValueAreaColor == valueAreaColor && cachenoftVolumeComposite[idx].ValueAreaColorAlpha == valueAreaColorAlpha && cachenoftVolumeComposite[idx].ValueAreaLevel == valueAreaLevel && cachenoftVolumeComposite[idx].VapColor == vapColor && cachenoftVolumeComposite[idx].VapColorAlpha == vapColorAlpha && cachenoftVolumeComposite[idx].VAPwidth == vAPwidth && cachenoftVolumeComposite[idx].EqualsInput(input))
                            return cachenoftVolumeComposite[idx];

                noftVolumeComposite indicator = new noftVolumeComposite();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.CalculationBarType = calculationBarType;
                indicator.DrawStyle = drawStyle;
                indicator.HeatColor = heatColor;
                indicator.MovingPeriodType = movingPeriodType;
                indicator.MovingPeriodValue = movingPeriodValue;
                indicator.ShowLowVolume = showLowVolume;
                indicator.ShowMaxLine = showMaxLine;
                indicator.ShowMaxVolume = showMaxVolume;
                indicator.ShowVaHighLine = showVaHighLine;
                indicator.ShowVaLowLine = showVaLowLine;
                indicator.ShowValueArea = showValueArea;
                indicator.SignalAlert = signalAlert;
                indicator.Sound = sound;
                indicator.ValueAreaColor = valueAreaColor;
                indicator.ValueAreaColorAlpha = valueAreaColorAlpha;
                indicator.ValueAreaLevel = valueAreaLevel;
                indicator.VapColor = vapColor;
                indicator.VapColorAlpha = vapColorAlpha;
                indicator.VAPwidth = vAPwidth;
                Indicators.Add(indicator);
                indicator.SetUp();

                noftVolumeComposite[] tmp = new noftVolumeComposite[cachenoftVolumeComposite == null ? 1 : cachenoftVolumeComposite.Length + 1];
                if (cachenoftVolumeComposite != null)
                    cachenoftVolumeComposite.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachenoftVolumeComposite = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftVolumeComposite noftVolumeComposite(string calculationBarType, string drawStyle, bool heatColor, string movingPeriodType, int movingPeriodValue, int showLowVolume, bool showMaxLine, bool showMaxVolume, bool showVaHighLine, bool showVaLowLine, bool showValueArea, bool signalAlert, string sound, Color valueAreaColor, int valueAreaColorAlpha, int valueAreaLevel, Color vapColor, int vapColorAlpha, int vAPwidth)
        {
            return _indicator.noftVolumeComposite(Input, calculationBarType, drawStyle, heatColor, movingPeriodType, movingPeriodValue, showLowVolume, showMaxLine, showMaxVolume, showVaHighLine, showVaLowLine, showValueArea, signalAlert, sound, valueAreaColor, valueAreaColorAlpha, valueAreaLevel, vapColor, vapColorAlpha, vAPwidth);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftVolumeComposite noftVolumeComposite(Data.IDataSeries input, string calculationBarType, string drawStyle, bool heatColor, string movingPeriodType, int movingPeriodValue, int showLowVolume, bool showMaxLine, bool showMaxVolume, bool showVaHighLine, bool showVaLowLine, bool showValueArea, bool signalAlert, string sound, Color valueAreaColor, int valueAreaColorAlpha, int valueAreaLevel, Color vapColor, int vapColorAlpha, int vAPwidth)
        {
            return _indicator.noftVolumeComposite(input, calculationBarType, drawStyle, heatColor, movingPeriodType, movingPeriodValue, showLowVolume, showMaxLine, showMaxVolume, showVaHighLine, showVaLowLine, showValueArea, signalAlert, sound, valueAreaColor, valueAreaColorAlpha, valueAreaLevel, vapColor, vapColorAlpha, vAPwidth);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.noftVolumeComposite noftVolumeComposite(string calculationBarType, string drawStyle, bool heatColor, string movingPeriodType, int movingPeriodValue, int showLowVolume, bool showMaxLine, bool showMaxVolume, bool showVaHighLine, bool showVaLowLine, bool showValueArea, bool signalAlert, string sound, Color valueAreaColor, int valueAreaColorAlpha, int valueAreaLevel, Color vapColor, int vapColorAlpha, int vAPwidth)
        {
            return _indicator.noftVolumeComposite(Input, calculationBarType, drawStyle, heatColor, movingPeriodType, movingPeriodValue, showLowVolume, showMaxLine, showMaxVolume, showVaHighLine, showVaLowLine, showValueArea, signalAlert, sound, valueAreaColor, valueAreaColorAlpha, valueAreaLevel, vapColor, vapColorAlpha, vAPwidth);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.noftVolumeComposite noftVolumeComposite(Data.IDataSeries input, string calculationBarType, string drawStyle, bool heatColor, string movingPeriodType, int movingPeriodValue, int showLowVolume, bool showMaxLine, bool showMaxVolume, bool showVaHighLine, bool showVaLowLine, bool showValueArea, bool signalAlert, string sound, Color valueAreaColor, int valueAreaColorAlpha, int valueAreaLevel, Color vapColor, int vapColorAlpha, int vAPwidth)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.noftVolumeComposite(input, calculationBarType, drawStyle, heatColor, movingPeriodType, movingPeriodValue, showLowVolume, showMaxLine, showMaxVolume, showVaHighLine, showVaLowLine, showValueArea, signalAlert, sound, valueAreaColor, valueAreaColorAlpha, valueAreaLevel, vapColor, vapColorAlpha, vAPwidth);
        }
    }
}
#endregion
